#include <minigui.ch>
#include 'hbclass.ch'
Function Main
	Public oConexion := openconnection("Datos.mdb")
	Public Pagina	 := 0
	Public oUser	 := TUsuario()	
	
	Set century on
	Set date british
	Set navigation extended
	
    Load Window Main
    Main.Center
    Main.Activate

Return

static procedure ajustar
	Main.image_1.row	:= 70
	Main.image_1.col	:= 0
	Main.image_1.width	:= Main.Width
	Main.image_1.height	:= Main.Height-175
	Main.Label_1.Row	:= Main.Image_1.row + Main.Image_1.Height
	Main.Label_1.Col	:= 0
	Main.Label_1.Width	:= Main.Image_1.Width
	Main.Label_1.Value	:= "Usuario : "+oUser:cName
return

function datos_empresa
	local o := Openrecordset(oConexion, "Select * from constantes")
	local cNombre := ""
	cNombre = o:Fields(2):value
	o:close()
return cNombre

function periodo
	local o := Openrecordset(oConexion, "Select * from constantes")
	local cAno := ""
	buscar_rs(o, 'id=7')
	cAno = o:Fields(2):value
	o:close()
return cAno

function carga_maestro(odb)
	local adata := {}
	local cTexto:= ""	
	if oDb:Recordcount > 0
		oDb:MoveFirst()
		do while !oDb:eof()
			cTexto := oDb:fields(1):value 
			aadd( adata, ToString(oDb:fields(0):value)+'-'+ Subs(cTexto,1,1)+lower(Subs(cTexto,2)))
			oDb:Movenext()	   
		enddo            		
	endif
return aData

static function validar_usuario
	local lExito := .f.
	load window login
	login.center
	activate window login
return lExito

static function codificar( cclave )
return validar_clave( codifica(login.text_1.value,login.text_2.value) )

static function validar_clave( ckey )
	local o := openrecordset( oConexion, "select * from login")
	local lexito := .f.
	
	if o:Recordcount > 0
		do while !o:eof()
			if rat( ckey, o:fields('pass'):value ) != 0
				oUser:cKey	:= cKey
				oUser:nId	:= o:Fields('id'):Value
				oUser:cUser	:= o:Fields('usuario'):value
				oUser:cName := o:Fields('nombre'):value
				oUser:nIdAcceso=o:Fields('IdAcceso'):value
				lExito := .t.
				o:MoveLast()
			endif
			o:MoveNext()
		enddo
	endif
	o:close()
	if !lExito
		Msgstop('Clave de usuario no valida')
	endif
return lExito
		

Class TUsuario
	Data cKey, cUser, cName Init ""
	Data nId, nIdAcceso Init 0
End Class

static procedure carga_menu
	 DEFINE MAIN MENU OF Main
        DEFINE POPUP "&Archivo"
        	
            MENUITEM "&Socios" ACTION proc101()
            if oUser:nIdAcceso = 1
            	MENUITEM "&Formas de pago" ACTION proc102()
            	DEFINE POPUP "&Cuentas"
            		MENUITEM "&Agrupacion de cuentas" ACTION proc108()
            		MENUITEM "&Cuentas" ACTION proc103()
            	END POPUP
            	MENUITEM "&Tipos de socios" ACTION proc104()
            	MENUITEM "&Religion" ACTION proc105()
            	MENUITEM "&Parametros" ACTION proc106()
            	MENUITEM "&Categoria" ACTION proc107()
            endif
            SEPARATOR
            MENUITEM "&Terminar" ACTION Main.release
        END POPUP
        DEFINE POPUP "&Transacciones"
            MENUITEM "&Comprobantes ingresos/egresos" ACTION proc201()
            MENUITEM "&Caja" ACTION proc202()
        END POPUP
        DEFINE POPUP "&Informes"
            MENUITEM "&Socios" ACTION proc301()
            MENUITEM "&Grupos de cuentas" ACTION proc303()
            MENUITEM "&Cuentas" ACTION proc302()
            MENUITEM "&Cumpleaos" ACTION proc402()
        END POPUP
        if oUser:nIdAcceso = 1
        	DEFINE POPUP "&Herramientas"
            	MENUITEM "&Mantencin de claves de usuario" ACTION proc401()
        	END POPUP
        endif
        DEFINE POPUP "&Ayuda"
            MENUITEM "&Acerca de ..." ACTION AcercaDe("Socios")
        END POPUP
    END MENU
	
return

