#include <minigui.ch>
#include 'adodb.ch'

procedure proc101
	Local oData
	
	if iswindowdefined( form101 )
		return
	endif
	
	With Object (odata:=structure())
	:member('socios', openrecordset(oconexion,'select * from socios'))
	:member('cat', openrecordset(oconexion,"select * from categorias"))
	:member('cta', openrecordset(oconexion,"select * from cuentas"))
	:member('rel', openrecordset(oconexion,"select * from religion"))
	:member('tip', openrecordset(oconexion,"select * from tiposocios"))
	:member('aux', openrecordset(oconexion,"select * from transaccionesauxiliar"))
	:member('acat',Carga_maestro(:cat))
	:member('acta',Carga_maestro(:cta))
	:member('arel',Carga_maestro(:rel))
	:member('atip',Carga_maestro(:tip))
	:member('nEdit',0)
	End With
	if odata:cat:recordcount = 0
		msgstop('Falta crear el maestro de categorias')
		cerrar(odata)
		return
	endif
	if odata:cta:recordcount = 0
		msgstop('falta crear el maestro de cuentas')
		cerrar(odata)
		return
	endif
	if odata:rel:recordcount = 0
		msgstop('falta crear el maestro de religiones')
		cerrar(odata)
		return
	endif
	if odata:tip:recordcount = 0
		msgstop('falta crear el maestro de tipos de socios')
		cerrar(odata)
		return
	endif
	
	load window form101
	form101.center
	form101.spinner_1.value := val(subs(dtos(date()),1,4))
	ON KEY ESCAPE OF FORM101 ACTION (oData:nEdit:=0, ESTADO_CONTROL(0,ODATA))
	activate window form101
return

static procedure puntero(n,odata)
	With Object oData
		if :Socios:Recordcount > 0
			do case
			case n = 1		
				:Socios:MoveFirst()	
			case n = 2
				:Socios:MovePrevious()
				if :Socios:bof()
					:Socios:MoveFirst()
				Endif
			case n = 3
				:Socios:MoveNext()
				if :Socios:eof()
					:Socios:Movelast()
				endif
			case n = 4
				:Socios:Movelast()
			endcase
		endif
	End With
	muestra_datos(odata)
return

static procedure muestra_datos(odata)
	if odata:Socios:Recordcount > 0
		With Object oData
			*- datos inicio
			form101.text_1.value		:= :Socios:fields('idSocio'):value
			form101.datepicker_1.value	:= stod(:Socios:fields('fecha_ingreso'):value)
			form101.text_2.value		:= :Socios:fields('tarjeta'):value
			*- datos personales			
			form101.text_3.value		:= :Socios:fields('rut'):value
			form101.text_4.value		:= :Socios:fields('dv'):value
			form101.text_5.value		:= :Socios:fields('nombres'):value
			form101.text_6.value		:= :Socios:fields('paterno'):value
			form101.text_7.value		:= :Socios:fields('materno'):value
			form101.datepicker_2.value	:= stod(:Socios:fields('fecha_nacimiento'):value)
			form101.combo_1.value		:= :Socios:fields('idreligion'):value
			form101.combo_2.value		:= :Socios:fields('civil'):value
			form101.combo_3.value		:= :Socios:fields('sexo'):value
			form101.text_8.value		:= if( empty(:Socios:fields('domiciliop'):value),"",:Socios:fields('domiciliop'):value)
			form101.text_9.value		:= if( empty(:Socios:fields('fonop'):value),"",:Socios:fields('fonop'):value)
			form101.text_10.value		:= if( empty(:Socios:fields('email'):value),"",:Socios:fields('email'):value)
			*- datos comerciales
			form101.text_11.value		:= if( empty(:Socios:fields('empresa'):value),"",:Socios:fields('empresa'):value)
			form101.text_12.value		:= if( empty(:Socios:fields('domicilioc'):value),"",:Socios:fields('domicilioc'):value)
			form101.text_13.value		:= if( empty(:Socios:fields('fonoc'):value),"",:Socios:fields('fonoc'):value)
			*- otros datos
			form101.combo_4.value		:= :Socios:fields('idcategoria'):value
			form101.combo_5.value		:= :Socios:fields('idtipo_socio'):value
			form101.combo_6.value		:= :Socios:fields('estado'):value
			*- Aqui falta llenar los registros de pago en ctacte.
			form101.grid_1.deleteallitems
			:aux:filter="idSocio="+tostring(:Socios:fields('IdSocio'):value)
			if :aux:recordcount > 0
				:aux:movefirst()
				do while !:aux:eof()
					*- Solo los registros del ao en curso.
					if subs( :aux:fields('fecha_emision'):value,1,4) = tostring(form101.spinner_1.value)
						form101.grid_1.additem({	tostring(:aux:fields('id'):value),;
													:aCta[:aux:fields('idcurso'):value],;
													:aux:fields('glosa'):value,;
													tostring(:aux:fields('ingreso'):value),;
													tostring(:aux:fields('egreso'):value),;
													dtoc(stod(:aux:fields('fecha_emision'):value)),;
													dtoc(stod(:aux:fields('fecha_vencimiento'):value)),;
													tostring(:aux:fields('boleta'):value) })
					endif												
					:aux:movenext()
				enddo											
			endif											
		End With		
	endif
return

static procedure estado_control(n,odata)
	local cControl 
	local i := 1
	
	* estado textbox
	for i= 1 to 13
		cControl = 'text_'+alltrim(str(i))
		if i = 1
			Setproperty('Form101',cControl,'ENABLED', .F.)
		else
			Setproperty('Form101',cControl,'ENABLED', if(n=0,.F.,.T.))
		endif
	Next
	* Estado combobox
	for i= 1 to 6
		cControl = 'combo_'+alltrim(str(i))
		Setproperty('Form101',cControl,'ENABLED', if(n=0,.F.,.T.))
	Next
	* Estado Datepicker
	for i= 1 to 2
		cControl = 'datepicker_'+alltrim(str(i))
		Setproperty('Form101',cControl,'ENABLED', if(n=0,.F.,.T.))
	Next
	
	if n > 0
		*- recargamos los maestros
		odata:member('acat',Carga_maestro(odata:cat))
		odata:member('acta',Carga_maestro(odata:cta))
		odata:member('arel',Carga_maestro(odata:rel))
		odata:member('atip',Carga_maestro(odata:tip))
		if n = 1
			form101.text_2.value := ""
			form101.text_3.value := 0
			form101.text_4.value := ""
			form101.text_5.value := ""
			form101.text_6.value := ""
			form101.text_7.value := ""
			form101.text_8.value := ""
			form101.text_9.value := ""
			form101.text_10.value:= ""
			form101.text_11.value:= ""
			form101.text_12.value:= ""
			form101.text_13.value:= ""
			form101.combo_1.value:= 1
			form101.combo_2.value:= 1
			form101.combo_3.value:= 1
			form101.combo_4.value:= 1
			form101.combo_5.value:= 1
			form101.combo_6.value:= 1
			form101.datepicker_1.value:= date()
			form101.datepicker_2.value:= date()
			form101.datepicker_1.setfocus
		else
			form101.text_5.setfocus
		endif
	endif
	
return

static function validar(n,odata)
	local o 
	local p, q 
	local cControl
	do case
	case n = 1
		if empty(form101.text_2.value)
			o := Openrecordset(oConexion, "Select tarjeta from socios order by tarjeta")
			if o:Recordcount > 0
				if valtype( o:fields('tarjeta'):value ) = 'C'
					p = Val(o:fields('tarjeta'):value)+1
					form101.text_2.value := str_zero( str(p), 8 )			
				else
					form101.text_2.value := str_zero( str(1), 8 )			
				endif					
			else
				form101.text_2.value	:= str_zero(str(1),1)
			endif
			o:close()
			return .f.
		endif
		if buscar_rs( odata:socios, "tarjeta='"+form101.text_2.value+"'")
			msgstop('Tarjeta ya existe')
			return .f.
		endif
		form101.text_2.value := str_zero( form101.text_2.value, 8 )
	case n = 2
		if form101.text_3.value = 0
			msgstop('Ingrese rut')
			return .f.
		endif		
		
		if Buscar_rs( oData:socios, "rut="+tostring(form101.text_3.value))
			msgstop('Socio ya existe')
			return .f.
		endif
	case n = 3
		if empty(form101.text_4.value)
			msgstop('ingrese digito verificador')
			return .f.
		endif
		if digito(ToString(form101.text_3.value)) <> form101.text_4.value
			msgstop('Error de digito verificador')
			return .f.
		endif
	case n = 4
		if empty(form101.text_5.value)
			msgstop('Ingrese nombre')
			return .f.
		endif
	case n = 5
		if empty(form101.text_6.value)
			msgstop('Ingrese apellido paterno')
			return .f.
		endif
	case n = 6
		if empty(form101.text_7.value)
			msgstop('Ingrese apellido materno')
			return .f.
		endif
	
	case n = 7
		if empty(form101.text_8.value)
			msgstop('Ingrese direccion')
			return .f.
		endif		
	case n = 11	
		Q = 0
		for i:= 2 to 7
			cControl= 'text_'+Tostring(i)
			p 	= GetProperty('form101',cControl,'Value')
			if valtype(p) = 'N'
				if p = 0
					q = i
				endif
			elseif valtype(p) = 'C'
				if empty(p)
					q = i
				endif
			endif
		next
		IF q > 0
			msgstop('Falta ingresar datos necesarios para mantener el registro'+hb_osnewline()+;
					'Por favor verifique los datos, complete y reintente.','Error')
			form101.text_2.setfocus					
			return .f.			
		endif		
		Try		
			With Object oData
				if :nEdit = 1
					:Socios:AddNew()
					:Socios:fields('fecha_ingreso'):value	:= dtos(form101.datepicker_1.value)
					:Socios:fields('tarjeta'):value 		:= str_zero(form101.text_2.value,8)
					:Socios:fields('rut'):value				:= form101.text_3.value
					:Socios:fields('dv'):value				:= form101.text_4.value
				else
					if !buscar_rs(:Socios, "idSocio="+Tostring(form101.text_1.value))
						msgstop('No se pudo recuperar el registro '+Tostring(form101.text_1.value))
					endif
				endif
				
				:Socios:fields('nombres'):value			:= form101.text_5.value
				:Socios:fields('paterno'):value			:= form101.text_6.value
				:Socios:fields('materno'):value			:= form101.text_7.value
				:Socios:fields('fecha_nacimiento'):value:= dtos(form101.datepicker_2.value)
				:Socios:fields('idreligion'):value		:= form101.combo_1.value
				:Socios:fields('civil'):value			:= form101.combo_2.value
				:Socios:fields('sexo'):value			:= form101.combo_3.value
				if !empty(form101.text_8.value)
					:Socios:fields('domiciliop'):value	:= form101.text_8.value
				endif
				if !empty(form101.text_9.value)
					:Socios:fields('fonop'):value		:= form101.text_9.value
				endif
				if !empty(form101.text_10.value)
					:Socios:fields('email'):value		:= form101.text_10.value
				endif
				if !empty(form101.text_11.value)
					:Socios:fields('empresa'):value		:= form101.text_11.value
				endif
				if !empty(form101.text_12.value)
					:Socios:fields('domicilioc'):value	:= form101.text_12.value
				endif
				if !empty(form101.text_13.value)
					:Socios:fields('fonoc'):value		:= form101.text_13.value
				endif
				:Socios:fields('idcategoria'):value		:= form101.combo_4.value
				:Socios:fields('idtipo_socio'):value	:= form101.combo_5.value
				:Socios:fields('estado'):value			:= form101.combo_6.value
				:Socios:Update()
					
			End With
		Catch e
			MsgStop("Operacin: "+e:operation+hb_osnewline()+"Descripcin: "+e:Description)	
			form101.release
		End Try
		oData:nEdit := 0
		Puntero(0,odata)			
		Estado_control(0,odata)
	endcase	
return .t.

static procedure borrar(odata)
	if odata:socios:fields('idSocio'):Value > 0
		if msgyesno('desea eliminar este registro','Confirmar')
			Try
				odata:socios:delete()
			Catch 
				For i:= 1 to oConexion:Errors:Count
					
						err := oConexion:Errors:item(i-1)
						msginfo(Tostring( err:Number )+" = "+err:Description )
						

				next
					odata:socios:CancelUpdate()
					odata:socios:MoveLast() 				
			end Try
		endif
	endif
return

static procedure buscar(odata)
	local adatos := {'Rut','Nombres','Paterno','Materno','Tarjeta'}	
	load window buscar
	buscar.center
	activate window buscar
	
return

static procedure ubicar_registro(odata)
	if buscar.grid_1.itemcount > 0
		if buscar_rs( odata:socios, "idSocio="+buscar.grid_1.cell(buscar.grid_1.value,1))
			muestra_datos(odata)
		endif
	endif
	buscar.release
return

static procedure ejecuta_buscar(odata)
	local i := 1, r
	local o
	local crut, cnombre
	
	if len(buscar.text_1.value)=0
		return
	endif
	r := GetGridColumnsCount('grid_1','buscar') 

	if r > 0
		for i= 1 to r
			buscar.grid_1.deletecolumn(1)
		next		
	endif
	buscar.text_1.enabled := .f.
	buscar.button_1.enabled := .f.
	buscar.button_2.enabled := .f.

	buscar.grid_1.addcolumn(1,'IdSocio',80,0)
	buscar.grid_1.addcolumn(2,'Rut',80,0)
	buscar.grid_1.addcolumn(3,'Nombre',80,0)
	buscar.grid_1.addcolumn(4,'Paterno',80,0)
	buscar.grid_1.addcolumn(5,'Materno',80,0)
	buscar.grid_1.addcolumn(6,'Tarjeta',80,0)
	do case
	case buscar.combo_1.value = 1	// Rut
	
		if !buscar_rs(odata:socios, "Rut="+buscar.text_1.value)	
			msgstop('Numero de rut no existe')
		else
			buscar.grid_1.additem({ tostring(odata:socios:fields('idsocio'):value),;
									tostring(odata:socios:fields('rut'):value),;
									odata:socios:fields('nombres'):value,;
									odata:socios:fields('paterno'):value,;
									odata:socios:fields('materno'):value,;
									odata:socios:fields('tarjeta'):value})									
		endif								
									
	case buscar.combo_1.value = 2
	    o = Openrecordset(oconexion, 	"Select idsocio,rut,nombres,paterno,materno, tarjeta "+;
	    								"from socios "+;
	    								"where nombres like '%"+buscar.text_1.value+"%'" )
	
		if o:recordcount = 0
			msgstop('No hay socios con nombre '+buscar.text_1.value)
		else
			buscar.grid_1.additem({ tostring(o:fields('idsocio'):value),;
									tostring(o:fields('rut'):value),;
									o:fields('nombres'):value,;
									o:fields('paterno'):value,;
									o:fields('materno'):value,;
									o:fields('tarjeta'):value})									
		endif								
		o:close()
	case buscar.combo_1.value = 3	
	    o = Openrecordset(oconexion, 	"Select idsocio,rut,nombres,paterno,materno, tarjeta "+;
	    								"from socios "+;
	    								"where PATERNO like '%"+buscar.text_1.value+"%'" )
	
		if o:recordcount = 0
			msgstop('No existen socios con apellido paterno '+buscar.text_1.value)
		else
			do while !o:eof()
				buscar.grid_1.additem({ tostring(o:fields('idsocio'):value),;
										tostring(o:fields('rut'):value),;
										o:fields('nombres'):value,;
										o:fields('paterno'):value,;
										o:fields('materno'):value,;
										o:fields('tarjeta'):value})									
				o:MoveNext()	
			enddo
		endif	
		o:close()		
	case buscar.combo_1.value = 4
	    o = Openrecordset(oconexion, 	"Select idsocio,rut,nombres,paterno,materno, tarjeta "+;
	    								"from socios "+;
	    								"where materno like '%"+buscar.text_1.value+"%'" )
	
		if o:recordcount = 0
			msgstop('No existen socios con apellido materno '+buscar.text_1.value)
		else
			do while !o:eof()
				buscar.grid_1.additem({ tostring(o:fields('idsocio'):value),;
										tostring(o:fields('rut'):value),;
										o:fields('nombres'):value,;
										o:fields('paterno'):value,;
										o:fields('materno'):value,;
										o:fields('tarjeta'):value})									
				o:MoveNext()	
			enddo
		endif	
		o:close()		
	case buscar.combo_1.value = 5
	    o = Openrecordset(oconexion, 	"Select idsocio,rut,nombres,paterno,materno, tarjeta "+;
	    								"from socios "+;
	    								"where tarjeta="+buscar.text_1.value )
	
		if o:recordcount = 0
			msgstop('No existen socios con tarjeta No '+buscar.text_1.value)
		else
			do while !o:eof()
				buscar.grid_1.additem({ tostring(o:fields('idsocio'):value),;
										tostring(o:fields('rut'):value),;
										o:fields('nombres'):value,;
										o:fields('paterno'):value,;
										o:fields('materno'):value,;
										o:fields('tarjeta'):value})									
				o:MoveNext()	
			enddo
		endif	
		o:close()		
	endcase
	buscar.text_1.enabled := .t.
	buscar.button_1.enabled := .t.
	buscar.button_2.enabled := .t.
	
return

static procedure imprimir(odata)
	local r := 0, i := 1, nIngreso := 0, nEgreso :=0
	
	Select Printer Default Preview
	
	Start printdoc
		Start PrintPage
			M->Pagina := 0
			Titulo('FICHA DE SOCIOS')
			@ 26, 10 print 'TARJETA No .......: '+form101.text_2.value font 'courier new' size 8
			@ 30, 10 print 'FECHA INGRESO.....: '+dtoc(form101.datepicker_1.value) font 'courier new' size 8
			@ 34, 10 print 'RUT...............: '+Transform(form101.text_3.value,'99,999,999')+'-'+form101.text_4.value  font 'courier new' size 8
			@ 38, 10 print 'NOMBRES...........: '+form101.text_5.value+' '+form101.text_6.value+' '+form101.text_7.value font 'courier new' size 8
			@ 42, 10 print 'F.NACIMIENTO......: '+dtoc(form101.datepicker_2.value) font 'courier new' size 8
			@ 46, 10 print 'RELIGION..........: '+form101.combo_1.item(form101.combo_1.value) font 'courier new' size 8
			@ 50, 10 print 'EST.CIVIL.........: '+form101.combo_2.item(form101.combo_2.value) font 'courier new' size 8
			@ 54, 10 print 'SEXO..............: '+form101.combo_3.item(form101.combo_3.value) font 'courier new' size 8
			@ 58, 10 print 'DOMICILIO PART....: '+form101.text_8.value font 'courier new' size 8
			@ 62, 10 print 'TELEFONO PART.....: '+form101.text_9.value font 'courier new' size 8
			@ 66, 10 print 'MAIL..............: '+form101.text_10.value font 'courier new' size 8			
			@ 70, 10 print 'EMPRESA...........: '+form101.text_11.value font 'courier new' size 8
			@ 74, 10 print 'DIRECCION COM.....: '+form101.text_12.value font 'courier new' size 8
			@ 78, 10 print 'TELEFONO COM......: '+form101.text_13.value font 'courier new' size 8
			@ 82, 10 print 'CATEGORIA.........: '+form101.combo_4.item(form101.combo_4.value) font 'courier new' size 8
			@ 86, 10 print 'ESTADO............: '+form101.combo_6.item(form101.combo_6.value) font 'courier new' size 8
			@ 90, 10 print 'CUENTA CORRIENTE PERIODO '+tostring(form101.spinner_1.value)
			
			subtitulo(94)
			r = 98
			
			for i= 1 to form101.grid_1.itemcount
				@ r, 10 print form101.grid_1.cell(i,2) font 'courier new' size 8
				@ r,100 print transform(val(form101.grid_1.cell(i,4)),'999,999') font 'courier new' size 8
				@ r,120 print transform(val(form101.grid_1.cell(i,5)),'999,999') font 'courier new' size 8
				@ r,140 print form101.grid_1.cell(i,6) font 'courier new' size 8
				@ r,160 print form101.grid_1.cell(i,7) font 'courier new' size 8
				@ r,180 print form101.grid_1.cell(i,8) font 'courier new' size 8
				nIngreso += val(form101.grid_1.cell(i,4))
				nEgreso	 += val(form101.grid_1.cell(i,5))
				r += 4
				If r > GetPrintableAreaHeight()-12
						PiePagina()
						End Printpage
						Start printpage
						Titulo('FICHA DE SOCIOS')
						@ 26, 10 print 'Tarjeta No' font 'courier new' size 8
						r = 30
						subtitulo(r)
						r=34
				endif								
			next
			@ r-.5, 10 PRINT LINE TO r-.5, GetPrintableAreaWidth()-10 PENWIDTH .2	
			@ r, 10 print 'TOTALES' font 'courier new' size 8
			@ r,100 print transform(nIngreso,'999,999') font 'courier new' size 8
			@ r,120 print transform(nEgreso,'999,999') font 'courier new' size 8
			@ r+4, 10 PRINT LINE TO r+4, GetPrintableAreaWidth()-10 PENWIDTH .2	
			
			piepagina()
		end Printpage
	End Printdoc
	
return

static procedure subtitulo(r)
	@ r-.5, 10 PRINT LINE TO r-.5, GetPrintableAreaWidth()-10 PENWIDTH .2	
	@ r, 10 print 'Sevicio' font 'courier new' size 8
	@ r,100 print 'Ingreso' font 'courier new' size 8
	@ r,120 print 'Egreso' font 'courier new' size 8
	@ r,140 print 'Emision' font 'courier new' size 8
	@ r,160 print 'Vencto.' font 'courier new' size 8
	@ r,180 print 'Boleta' font 'courier new' size 8
	@ r+4, 10 PRINT LINE TO r+4, GetPrintableAreaWidth()-10 PENWIDTH .2	
return

static procedure cerrar(odata)
	With object odata
	:socios:close()
	:cat:close()
	:cta:close()
	:rel:close()
	:tip:close()
	:aux:close()
	end With
	odata:release()
return

static function codigo(ctexto)
return val( subs( cTexto, 1, rat('-',ctexto)-1 ) )