#include <minigui.ch>
#include 'adodb.ch'
procedure proc102
	Local oData
	
	if iswindowdefined( form102 )
		return
	endif
	
	oData:= Structure()
	oData:member("ColumnControls",{{'TEXTBOX','NUMERIC'},{'TEXTBOX','CHARACTER'}})
	oData:member("Headers",{'Codigo','Descripcion'})
	oData:member("Items", {{0,""}})
	oData:member("widths",{ 80, 200 })
	oData:member("fPago", OpenRecordset(oConexion, "Select * from formaspago order by idFPago"))

	load window form102
	form102.center
	ON KEY ESCAPE OF Form102 ACTION estado_control(0)
	activate window form102
	
return

static procedure estado_control(n)
	local lNuevo := if(form102.grid_1.cell(form102.grid_1.value,1) = 0, .T., .F. )
	form102.text_1.enabled:= .f.
	form102.text_2.enabled:= .f.
	if n > 0		
		form102.grid_1.enabled:= .f.
		form102.text_2.enabled:= .t.
		form102.text_1.value	:= if( lNuevo, 0, form102.text_1.value)
		form102.text_2.value	:= if( lNuevo, "",form102.text_2.value)		
		form102.text_2.setfocus
		return
	endif
	form102.grid_1.enabled:= .t.
	form102.grid_1.setfocus
return

static procedure muestra_datos
	form102.text_1.value	:= form102.grid_1.cell(form102.grid_1.value,1)
	form102.text_2.value	:= form102.grid_1.cell(form102.grid_1.value,2)
return

static procedure carga_pagina( odata )
	With Object oData
		llenar_grid(:fPago, {"IdFPago","Descripcion"}, "FORM102","Grid_1", .T.)
	End With
return

static function validar(odata)
	if empty( form102.text_2.value)
		msgstop('Ingrese descripcion')
		return .f.
	endif
	Try
		With Object oData
			
			if form102.text_1.value = 0
				:fpago:Addnew()
			else
				buscar_rs(:fpago, "idfpago="+tostring(form102.text_1.value))
			endif
			:fpago:fields('descripcion'):value:= form102.text_2.value
			:fpago:update()
			if form102.text_1.value = 0
				:fpago:Movelast()
			endif
			form102.grid_1.cell(form102.grid_1.value,1):= :fpago:fields('idfpago'):value
			form102.grid_1.cell(form102.grid_1.value,2):= :fpago:fields('descripcion'):value
			grid_eof('form102','grid_1')
		End With	
	Catch e
		MsgStop("Operacin: "+e:operation+hb_osnewline()+"Descripcin: "+e:Description)	
		form102.release
	End Try
	estado_control(0)	
return

static procedure buscar
	local aResp := buscar_datos({'Codigo','Descripcion'})
	local npos  := 0
	if aResp[1] > 0
		npos = grid_buscar('form102','grid_1',aresp[2],aresp[1])
		if npos > 0
			form102.grid_1.value := npos
		else
			msgstop('Registro no encontrado')
		endif
	endif
return

static procedure borrar(odata)
	if form102.grid_1.cell(form102.grid_1.value,1) > 0
		if Eliminar()
			With Object oData
				if buscar_rs( :fpago, "idfpago="+tostring(form102.grid_1.cell(form102.grid_1.value,1)))
					:fpago:delete()
					:fpago:update()
					form102.grid_1.deleteitem( form102.grid_1.value )
				endif
			End with
		endif
	endif
return

static procedure imprimir
	local r := 30
	
	Select printer Default Preview
	start printdoc
		start printpage
			M->Pagina := 0
			Titulo('FORMAS DE PAGO')
			Subtitulo({{'Codigo',10},{'Descripcion',30}})
			for i := 1 to form102.grid_1.itemcount-1
				@ r, 12 print form102.grid_1.cell(i,1) 
				@ r, 30 print form102.grid_1.cell(i,2) 
				r+=4
				if r > GetPrintableAreaHeight()-12
					PiePagina()
					End Printpage
					Start printpage
					Titulo('FORMAS DE PAGO')
					Subtitulo({{'Codigo',10},{'Descripcion',30}})
					r = 30
				endif										
			next
			Piepagina()
		end printpage
	end printdoc		
	
return

static procedure cerrar( o )
	o:fpago:close()
	o:release()
return
	