#include <minigui.ch>
#include 'adodb.ch'

procedure proc103
	local odata
	
	if iswindowdefined( form103 )
		return
	endif
	oData := structure()
	odata:member("ColumnControls",{{"TEXTBOX","NUMERIC"},{'TEXTBOX','CHARACTER'},{"TEXTBOX","NUMERIC"}})
	odata:member("Headers",{'Codigo','Descripcion','Estado'})
	odata:member("Items",{{0,"",0}})
	odata:member("Widths",{80,200,0})
	odata:member("Headers2",{'Periodo','Ingresos','Acumulado'})
	odata:member("Items2",{{"","",""}})
	odata:member("Widths2",{80,100,100})
	odata:member("Cursos", Openrecordset(oConexion,"Select * from cuentas"))
	odata:member("aux", Openrecordset(oConexion, "Select * from transaccionesAuxiliar"))
	load window form103
	form103.center
	ON KEY ESCAPE OF Form103 ACTION Estado_control(0)
	activate window form103
return

static procedure muestra_datos
	local aDatos:= form103.grid_1.item( form103.grid_1.value )
	form103.text_1.value	:= aDatos[1]
	form103.text_2.value	:= aDatos[2]
	form103.combo_1.value	:= if(aDatos[3]= 0, 1,aDatos[3])
	if form103.tab_1.value = 2
		muestra_saldos(odata)
	endif
return

static procedure estado_control(n)
	form103.text_1.enabled	:= .f.
	form103.text_2.enabled	:= .f.
	form103.combo_1.enabled	:= .f.
	form103.grid_1.enabled 	:= .t.
	if n > 0
		form103.grid_1.enabled := .f.
		form103.text_2.enabled	:= .t.
		form103.combo_1.enabled	:=.t.
		if form103.grid_1.cell(form103.grid_1.value,1) = 0
			form103.text_2.value:= ""
			form103.combo_1.value:= 1
		endif
		form103.text_2.setfocus
	else
		form103.grid_1.setfocus
	endif			
return

static procedure carga_pagina(odata)
	With Object odata
		llenar_grid(:Cursos,{'IdCurso','Descripcion','Estado'},'form103','grid_1',.t.)
	End With
return

static function validar(n,odata)
	do case
	case n = 1
		if empty( form103.text_2.value )
			msgstop('Ingrese descripcion')
			return .f.
		endif
	case n = 2
		Try
			With Object oData
				if form103.grid_1.cell(form103.grid_1.value,1) = 0
					:Cursos:AddNew()
				else
					buscar_rs(:Cursos,"idCurso="+ToString(form103.grid_1.cell(form103.grid_1.value,1)))
				endif
				:Cursos:Fields('Descripcion'):Value := form103.text_2.value
				:Cursos:Fields('Estado'):Value		:= form103.combo_1.value
				:Cursos:Update()
				if form103.grid_1.cell(form103.grid_1.value,1) = 0
					:Cursos:MoveLast()
				endif
				form103.grid_1.cell(form103.grid_1.value,1):=oData:Cursos:Fields('IdCurso'):Value
				form103.grid_1.cell(form103.grid_1.value,2):=oData:Cursos:Fields('Descripcion'):Value
				form103.grid_1.cell(form103.grid_1.value,3):=oData:Cursos:Fields('Estado'):Value
				grid_eof('form103','grid_1')
			End With
		Catch e
			MsgStop("Operacin: "+e:operation+hb_osnewline()+"Descripcin: "+e:Description)	
			form103.release
		End Try
		estado_control(0)					
	endcase
return .t.

static procedure muestra_saldos(odata)
	local cAno := Periodo()
	local aAcumulado :={}
	local nMes := 0
	form103.label_4.value	:= 'Servicio : '+form103.grid_1.cell(form103.grid_1.value,2)
	form103.grid_2.deleteallitems
	for i := 1 to 12
		aadd( aAcumulado, {NombreMes()[i], 0, 0 })
	next
	With Object oData
		:aux:filter="idCurso="+tostring(form103.grid_1.cell(form103.grid_1.value,1))
		
		if :aux:recordcount > 0
			:aux:Movefirst()
			do while !:aux:eof()
				if subs( :aux:fields('fecha_emision'):value,1,4) = cAno
					nMes = val( subs( :aux:fields('fecha_emision'):value,5,2) )
					aAcumulado[ nMes, 2 ] ++
					aAcumulado[ nMes, 3 ] ++
				endif
				:aux:Movenext()
			enddo
		endif
	End With
	
	For i= 1 to len( aAcumulado )
		if i = 1
			aAcumulado[i,3] = aAcumulado[i,2]
		else
			aAcumulado[i,3] = aAcumulado[i-1,3]+aAcumulado[i,2]
		endif
		form103.grid_2.additem( { aAcumulado[i,1], Tostring(aAcumulado[i,2]), Tostring(aAcumulado[i,3]) } )
	next
return

static procedure buscar
	local aResp := buscar_datos({'Codigo','Descripcion'})
	local npos  := 0
	if aResp[1] > 0
		npos = grid_buscar('form103','grid_1',aresp[2],aresp[1])
		if npos > 0
			form103.grid_1.value := npos
		else
			msgstop('Registro no encontrado')
		endif
	endif
return

static procedure borrar(odata)
	if form103.grid_1.cell(form103.grid_1.value,1) > 0
		if Eliminar()
			With Object oData
				if buscar_rs( :Cursos, "idCurso="+tostring(form103.grid_1.cell(form103.grid_1.value,1)))
					:Cursos:delete()
					:Cursos:update()
					form103.grid_1.deleteitem( form103.grid_1.value )
				endif
			End with
		endif
	endif
return

static procedure imprimir
	local r := 30
	
	Select printer Default Preview
	start printdoc
		start printpage
			M->Pagina := 0
			Titulo('LISTADO DE CURSOS/SERVICIOS')
			Subtitulo({{'Codigo',10},{'Descripcion',30},{'Estado',120}})
			for i := 1 to form103.grid_1.itemcount-1
				@ r, 12 print form103.grid_1.cell(i,1) 
				@ r, 30 print form103.grid_1.cell(i,2) 
				@ r,120 print if(form103.grid_1.cell(i,3)=1,'Disponible','No Disponible') 
				r+=4
				if r > GetPrintableAreaHeight()-12
					PiePagina()
					End Printpage
					Start printpage
					Titulo('LISTADO DE CURSOS/SERVICIOS')
					Subtitulo({{'Codigo',10},{'Descripcion',30},{'Estado',120}})
					r = 30
				endif										
			next
			Piepagina()
		end printpage
	end printdoc		
	
return

static procedure cerrar( o )
	o:cursos:close()
	o:aux:close()
	o:release()
return
	