#include <minigui.ch>
#include 'adodb.ch'

procedure proc105
	Local oData
	
	if iswindowdefined( form105 )
		return
	endif
	
	oData:= Structure()
	oData:member("ColumnControls",{{'TEXTBOX','NUMERIC'},{'TEXTBOX','CHARACTER'}})
	oData:member("Headers",{'Codigo','Descripcion'})
	oData:member("Items", {{0,""}})
	oData:member("widths",{ 80, 200 })
	oData:member("oReligion", OpenRecordset(oConexion, "Select * from Religion"))

	load window form105
	form105.center
	ON KEY ESCAPE OF Form105 ACTION estado_control(0)
	activate window form105
	
return

static procedure estado_control(n)
	local lNuevo := if(form105.grid_1.cell(form105.grid_1.value,1) = 0, .T., .F. )
	form105.text_1.enabled:= .f.
	form105.text_2.enabled:= .f.
	if n > 0		
		form105.grid_1.enabled:= .f.
		form105.text_2.enabled:= .t.
		form105.text_1.value	:= if( lNuevo, 0, form105.text_1.value)
		form105.text_2.value	:= if( lNuevo, "",form105.text_2.value)		
		form105.text_2.setfocus
		return
	endif
	form105.grid_1.enabled:= .t.
	form105.grid_1.setfocus
return

static procedure muestra_datos
	form105.text_1.value	:= form105.grid_1.cell(form105.grid_1.value,1)
	form105.text_2.value	:= form105.grid_1.cell(form105.grid_1.value,2)
return

static procedure carga_pagina( odata )
	With Object oData
		llenar_grid(:oReligion, {"IdReligion","Descripcion"}, "FORM105","Grid_1", .T.)
	End With
return

static function validar(odata)
	if empty( form105.text_2.value)
		msgstop('Ingrese descripcion')
		return .f.
	endif
	Try
		With Object oData
			if form105.text_1.value = 0
				:oReligion:Addnew()
			else
				buscar_rs(:oReligion, "idReligion="+tostring(form105.text_1.value))
			endif
			:oReligion:fields('descripcion'):value:= form105.text_2.value
			:oReligion:update()
			if form105.text_1.value = 0
				:oReligion:Movelast()
			endif
			form105.grid_1.cell(form105.grid_1.value,1):= :oReligion:fields('idReligion'):value
			form105.grid_1.cell(form105.grid_1.value,2):= :oReligion:fields('descripcion'):value
			grid_eof('form105','grid_1')
		End With	
	Catch e
		MsgStop("Operacin: "+e:operation+hb_osnewline()+"Descripcin: "+e:Description)	
		form105.release
	End Try
	estado_control(0)	
return

static procedure buscar
	local aResp := buscar_datos({'Codigo','Descripcion'})
	local npos  := 0
	if aResp[1] > 0
		npos = grid_buscar('form105','grid_1',aresp[2],aresp[1])
		if npos > 0
			form105.grid_1.value := npos
		else
			msgstop('Registro no encontrado')
		endif
	endif
return

static procedure borrar(odata)
	if form105.grid_1.cell(form105.grid_1.value,1) > 0
		if Eliminar()
			With Object oData
				if buscar_rs( :oReligion, "idReligion="+tostring(form105.grid_1.cell(form105.grid_1.value,1)))
					:oReligion:delete()
					:oReligion:update()
					form105.grid_1.deleteitem( form105.grid_1.value )
				endif
			End with
		endif
	endif
return

static procedure imprimir
	local r := 30
	
	Select printer Default Preview
	start printdoc
		start printpage
			M->Pagina := 0
			Titulo('RELIGION')
			Subtitulo({{'Codigo',10},{'Descripcion',30}})
			for i := 1 to form105.grid_1.itemcount-1
				@ r, 12 print form105.grid_1.cell(i,1) 
				@ r, 30 print form105.grid_1.cell(i,2) 
				r+=4
				if r > GetPrintableAreaHeight()-12
					PiePagina()
					End Printpage
					Start printpage
					Titulo('RELIGION')
					Subtitulo({{'Codigo',10},{'Descripcion',30}})
					r = 30
				endif										
			next
			Piepagina()
		end printpage
	end printdoc		
	
return

static procedure cerrar( o )
	o:oReligion:close()
	o:release()
return
	