#include <minigui.ch>
#include 'adodb.ch'

procedure proc201
	local odata
	
	if iswindowdefined(form201)
		return
	endif
	
	with object (odata:=structure())
	:member("mae", openrecordset(oconexion,"select * from transaccionesMaestro"))
	:member("aux", openrecordset(oconexion,"select * from TransaccionesAuxiliar"))
	:member("socios", openrecordset(oconexion,"select * from socios"))
	:member("fpago", openrecordset(oconexion,"select * from formaspago"))
	:member("cta", openrecordset(oconexion,"select * from cuentas"))
	:member("apago",carga_maestro(odata:fpago))
	:member("acurso",carga_maestro(odata:cta))
	:member("nEdit",0)
	:member('nDetalle',0)
	:member('columncontrols',{	{'TEXTBOX','NUMERIC'},;
								{'COMBOBOX',odata:acurso},;
								{'TEXTBOX','CHARACTER'},;
								{'COMBOBOX',{'I','E'}},;
								{'TEXTBOX','NUMERIC','999,999'},;
								{'TEXTBOX','NUMERIC','999,999'}})
	:member('columnvalid',	{	{ || .f. },;
								{ || validar(3,odata) },;								
								{ || validar(4,odata)},;								
								{ || validar(5,odata) },;								
								{ || validar(6,odata) },;								
								{ || validar(7,odata) }})
	:member('columnwhen',	{	{ || .f. },;
								{ || .t. },;								
								{ || .t. },;								
								{ || .t. },;								
								{ || .t. },;								
								{ || .t. } })
	:member('headers',		{'','Servicio','Glosa','Mov','Ingreso','Egreso'})
	:member('items',		{{ 0, 1, '', 1, 0, 0}})
	:member('widths',		{0, 100, 100, 40, 70, 70})										
	end with
		
	load window form201
	form201.center
	ON KEY ESCAPE OF form201 ACTION if( oData:nDetalle=1,Control_Grid(oData:nDetalle:=0),Estado_control(0,odata))
	ON KEY DELETE OF form201 ACTION Borrar_registro(odata)
	activate window form201
	
return

static procedure puntero(n,odata)
	With Object oData
		if :Mae:Recordcount > 0
			do case
			case n = 1	
				:Mae:Movefirst()
			case n = 2
				:Mae:MovePrevious()
				if :Mae:bof()
					:Mae:MoveFirst()
				endif
			case n = 3
				:Mae:MoveNext()
				if :Mae:eof()
					:Mae:MoveLast()
				endif
			case n = 4
				:Mae:MoveLast()
			endcase
		endif
	End With
	muestra_datos(odata)
return

static procedure estado_control(n,odata)
	local cControl := ""
	local i := 0
	if odata:mae:eof() .and. odata:mae:recordcount > 0
		odata:mae:movelast()
	endif
	if n = 2
		if odata:mae:fields('estado'):value = 2
			msgstop('No se puede modificar un documento nulo')
			return
		elseif odata:mae:fields('estado'):value = 1
			msgstop('No se puede modificar un documento cerrado')
			return
		endif
	endif
	*- control textbox
	form201.text_1.enabled := .f.
	for i= 2 to 6
		cControl = 'text_'+alltrim(str(i))
		SetProperty("form201",cControl,'Enabled', IF( n > 0, .T., .F. ) )
	Next
	*- control datepicker
	form201.datepicker_1.enabled:= IF( n > 0, .T., .F. )
	form201.datepicker_2.enabled:= IF( n > 0, .T., .F. )
	*- control combobox
	form201.combo_1.enabled		:= IF( n > 0, .T., .F. )
	*- control grid
	form201.grid_2.enabled		:= .f.
	form201.grid_1.enabled		:= .t.
	form201.combo_2.enabled		:= .f.
	form201.combo_3.enabled		:= .f.
	form201.text_7.enabled		:= .f.
	form201.text_8.enabled		:= .f.
	if n = 1	
		form201.text_1.value		:= 0
		form201.datepicker_1.value	:= date()
		form201.text_2.value		:= 0
		form201.text_3.value		:= 0
		form201.grid_2.deleteallitems
		form201.text_4.value		:= ""
		form201.text_5.value		:= ""
		form201.text_6.value		:= ""
		form201.combo_1.value		:= 1
		form201.grid_1.deleteallitems
		form201.grid_1.additem( odata:items[1] )
	endif
	if n <> 0		
		form201.datepicker_1.setfocus
	endif					
return

static procedure control_grid(n)
	if form201.text_2.enabled
		form201.grid_1.enabled	:= .t.
		form201.combo_2.enabled	:= .f.
		form201.combo_3.enabled	:= .f.
		form201.text_7.enabled	:= .f.
		form201.text_8.enabled	:= .f.
		if n<>0
			form201.grid_1.enabled	:= .f.
			form201.combo_2.enabled	:= .t.
			form201.combo_3.enabled	:= .t.
			form201.text_7.enabled	:= .t.
			form201.text_8.enabled	:= .t.
			form201.combo_2.setfocus
			return
		endif		
	endif
return

static procedure muestra_datos_grid
	form201.combo_2.value	:= if( form201.grid_1.cell(form201.grid_1.value,2)>0,form201.grid_1.cell(form201.grid_1.value,2),1)
	form201.text_7.value	:= form201.grid_1.cell(form201.grid_1.value,3)
	form201.combo_3.value	:= if( form201.grid_1.cell(form201.grid_1.value,4)>0,form201.grid_1.cell(form201.grid_1.value,4),1)
	if form201.combo_3.value = 1
		form201.text_8.value:= form201.grid_1.cell(form201.grid_1.value,5)
	elseif form201.combo_3.value = 2
		form201.text_8.value:= form201.grid_1.cell(form201.grid_1.value,6)
	else
		form201.text_8.value:= 0
	endif
return

static procedure muestra_datos(odata)
	local aEstado :={'Activo','Cerrado','Nulo'}
	if oData:mae:recordcount > 0
		*- Encabezado
		With object odata
			form201.text_1.value		:= :mae:fields('idMaestro'):value
			form201.datepicker_1.value	:= stod(:mae:fields('fecha_emision'):value)
			form201.text_2.value		:= :mae:fields('boleta'):value
			
			buscar_socio(odata, :mae:fields('idsocio'):value)
			form201.text_4.value		:= :mae:fields('glosa'):value
			form201.combo_1.value		:= :mae:fields('idfpago'):value
			form201.text_5.value		:= :mae:fields('banco'):value
			form201.text_6.value		:= :mae:fields('cheque_num'):value
			form201.datepicker_2.value	:= stod(:mae:fields('vencimiento'):value)
			
			*- Detalle
			:aux:filter="idMaestro="+tostring(form201.text_1.value)
			llenar_grid(:aux, {'Id','IdCurso','Glosa','TipoMovimiento','Ingreso','Egreso'},'form201','grid_1',.t.)
			form201.label_14.Value := 'Estado comprobante '+aEstado[ :mae:fields('estado'):value+1 ]
		end with
		
	endif
return

static function buscar_socio(odata, nId )
	form201.grid_2.deleteallitems
	With Object oData
		if buscar_rs(:socios,'idSocio='+tostring(nId))
			form201.text_3.value	:= :socios:fields('rut'):value
			form201.grid_2.additem({'Tarjeta',	:socios:fields('tarjeta'):value})
			form201.grid_2.additem({'Socio ',	:socios:fields('nombres'):Value+' '+;
												:socios:fields('paterno'):Value+' '+;
												:socios:fields('materno'):Value })
			form201.grid_2.additem({'Direccion',:socios:fields('domiciliop'):value})												
		endif
	End With									
return .t.

static function validar(n,odata)
	local o
	local resp, I
	
	do case
	case n = 1
		if form201.text_2.value = 0
			msgstop('Ingrese numero de boleta')
			return .f.
		endif
	case n = 2
		if form201.text_3.value = 0
			o = Openrecordset( oConexion, "Select Rut,Nombres,paterno,materno from socios")
			resp = consulta_maestro( o,,1)
			if valtype(resp) != 'N'
				msgstop('Debe seleccionar un rut o ingresar uno valido')
				o:close()
				return .f.
			endif
			o:close()
			form201.text_3.value := resp			
		endif
		odata:socios:requery()
		if !buscar_rs( odata:Socios, "rut="+tostring(form201.text_3.value))
			msgstop('Socio no existe')
			return .f.
		endif		
		buscar_socio(odata, odata:socios:fields('idSocio'):value )	
	case n = 3
		if _HMG_SYSDATA[318] = 0
			MSGSTOP('Seleccione servicio')
			return .f.
		endif
	case n = 4	
	case n = 5
		if _HMG_SYSDATA[318] = 0
			_HMG_SYSDATA[318] = 1
		ENDIF	
	case n = 6
	case n = 7
		Try				
			With Object oData
			
				*- graba datos al maestro.
				if form201.text_1.value = 0
					:mae:addnew()
					:mae:fields('boleta'):value := form201.text_2.value							
				elseif !buscar_rs( :mae, "idMaestro="+tostring(form201.text_1.value))
					msgstop('No se pudo ubicar el documento actual'+hb_osnewline()+;	
							'Avise al administrador','Error de actualizacion')
				endif
				:mae:fields('fecha_emision'):value	:= dtos(form201.datepicker_1.value)
				:mae:fields('IdSocio'):value		:= :Socios:fields('IdSocio'):value
				:mae:fields('IdFPago'):value		:= form201.combo_1.value
				:mae:fields('glosa'):value			:= form201.text_4.value
				:mae:fields('cheque_num'):value		:= form201.text_6.value
				:mae:fields('banco'):value			:= form201.text_5.value
				if day(form201.datepicker_2.value)>0
					:mae:fields('vencimiento'):value:= dtos(form201.datepicker_2.value)
				endif
				:mae:update()
				
				buscar_rs(:mae, "boleta="+tostring(form201.text_2.value))
				form201.text_1.value	:= :mae:fields('idMaestro'):value
				
				if form201.grid_1.cell(form201.grid_1.value,1) = 0
					:aux:addnew()
				else
					buscar_rs(:aux,"id="+ToString(form201.grid_1.cell(form201.grid_1.value,1)))
				endif
				:aux:fields('idmaestro'):value 			:= form201.text_1.value
				:aux:fields('idcurso'):value			:= form201.combo_2.value
				:aux:fields('glosa'):value				:= form201.text_7.value
				:aux:fields('TipoMovimiento'):value		:= form201.combo_3.value
				:aux:fields('Ingreso'):value			:= if(form201.combo_3.value=1, form201.text_8.value,0)
				:aux:fields('Egreso'):value				:= if(form201.combo_3.value=2, form201.text_8.value,0)
				:aux:fields('boleta'):value				:= form201.text_2.value
				:aux:fields('fecha_emision'):value		:= dtos(form201.datepicker_1.value)
				:aux:fields('fecha_vencimiento'):value	:= dtos(form201.datepicker_1.value+30)
				:aux:fields('IdSocio'):value			:= :Socios:fields('IdSocio'):value
				:aux:update()
				:aux:requery()
				i = form201.grid_1.value
				if form201.grid_1.cell( form201.grid_1.value, 1 ) = 0
					form201.grid_1.deleteallitems
					:aux:filter="idMaestro="+tostring(form201.text_1.value)
					:aux:Movefirst()				
					llenar_grid(:aux, {'Id','IdCurso','Glosa','TipoMovimiento','Ingreso','Egreso'},'form201','grid_1',.t.)
					form201.grid_1.value := i
				endif				
				form201.grid_1.setfocus
				odata:nDetalle = 0
				control_grid(0,odata)
			End With
		Catch e
			MsgStop("Operacin: "+e:operation+hb_osnewline()+"Descripcin: "+e:Description)	
			form201.release
		End Try
	endcase	
return .t.

static procedure buscar_registro(odata)
	local aDatos:= {'Folio','Boleta','Rut'}
	load window buscar
	buscar.center
	activate window buscar
return

static procedure ubicar_registro(odata)
	if buscar.grid_1.itemcount > 0
		if buscar_rs( odata:mae, "idMaestro="+buscar.grid_1.cell(buscar.grid_1.value,1))
			Puntero(0,odata)
		endif
	endif
	buscar.release
return

static procedure ejecuta_buscar(odata)
	local i := 1, r
	local o
	local crut, cnombre
	if len(buscar.text_1.value)=0
		return
	endif
	r := GetGridColumnsCount('grid_1','buscar') 

	if r > 0
		for i= 1 to r
			buscar.grid_1.deletecolumn(1)
		next		
	endif
	buscar.text_1.enabled := .f.
	buscar.button_1.enabled := .f.
	buscar.button_2.enabled := .f.
	buscar.grid_1.addcolumn(1,'Folio',80,0)
	buscar.grid_1.addcolumn(2,'Fecha',80,0)
	buscar.grid_1.addcolumn(3,'Boleta',80,0)
	buscar.grid_1.addcolumn(4,'Rut',80,0)
	buscar.grid_1.addcolumn(5,'Nombre',80,0)

	do case
	case buscar.combo_1.value = 1
	
		if !buscar_rs(odata:mae, "idMaestro="+buscar.text_1.value)	
			msgstop('Numero de Folio no existe')
		else
			cRut	= if(buscar_rs(odata:socios,"idsocio="+Tostring(odata:mae:fields('idsocio'):value)), oData:socios:fields('rut'):value, 0)
			cNombre	= if(buscar_rs(odata:socios,"idsocio="+Tostring(odata:mae:fields('idsocio'):value)), oData:socios:fields('nombres'):value+' '+;
																										oData:socios:fields('paterno'):value+' '+;
																										oData:socios:fields('materno'):value,;
																										 "")
			buscar.grid_1.additem({ tostring(odata:mae:fields('idmaestro'):value),;
									dtoc(stod(odata:mae:fields('fecha_emision'):value)),;
									tostring(odata:mae:fields('boleta'):value),;
									crut, cnombre })
		endif								
									
	case buscar.combo_1.value = 2
		if !buscar_rs(odata:mae, "boleta="+buscar.text_1.value)	
			msgstop('Numero de Boleta no existe')
		else
			cRut	= if(buscar_rs(odata:socios,"idsocio="+Tostring(odata:mae:fields('idsocio'):value)),oData:socios:fields('rut'):value, 0)
			cNombre	= if(buscar_rs(odata:socios,"idsocio="+Tostring(odata:mae:fields('idsocio'):value)),oData:socios:fields('nombres'):value+' '+;
																										oData:socios:fields('paterno'):value+' '+;
																										oData:socios:fields('materno'):value,;
																										"")
			buscar.grid_1.additem({ tostring(odata:mae:fields('idmaestro'):value),;
									dtoc(stod(odata:mae:fields('fecha_emision'):value)),;
									tostring(odata:mae:fields('boleta'):value),;
									crut, cnombre })
		endif								
	case buscar.combo_1.value = 3	
		if !buscar_rs( odata:socios, "rut="+buscar.text_1.value)
			msgstop('No existe rut '+buscar.text_1.value)
		else
			odata:mae:filter="idSocio="+tostring(odata:socios:fields('idsocio'):value)
			if oData:mae:recordcount > 0
				odata:mae:movefirst()
				do while !odata:mae:eof()
					cRut	= if(buscar_rs(odata:socios,"idsocio="+Tostring(odata:mae:fields('idsocio'):value)),oData:socios:fields('rut'):value, 0)
					cNombre	= if(buscar_rs(odata:socios,"idsocio="+Tostring(odata:mae:fields('idsocio'):value)),oData:socios:fields('nombres'):value+' '+;
																												oData:socios:fields('paterno'):value+' '+;
																												oData:socios:fields('materno'):value,;
																												"")
					buscar.grid_1.additem({ tostring(odata:mae:fields('idmaestro'):value),;
											dtoc(stod(odata:mae:fields('fecha_emision'):value)),;
											tostring(odata:mae:fields('boleta'):value),;
											crut, cnombre })
					oData:Mae:MoveNext()	
				enddo
			else
				msgstop('No hay registros relacionados con el rut')
			endif
			oData:Mae:Filter=""
		endif			
	endcase
	buscar.text_1.enabled := .t.
	buscar.button_1.enabled := .t.
	buscar.button_2.enabled := .t.
	
return

static procedure imprimir(odata)
	local r := 0, i := 1, nIngreso := 0, nEgreso :=0
	
	Select Printer Default Preview
	
	Start printdoc
		Start PrintPage
			M->Pagina := 0
			Titulo('COMPROBANTE No '+Tostring(form201.text_1.value), form201.datepicker_1.value)
			@ 24, 10 print 'Boleta No ..........: '+tostring(form201.text_2.value) font 'courier new' size 8
			@ 28, 10 print 'IDENTIFICACION DEL SOCIO' font 'courier new' size 9
			@ 32, 10 print 'Socio ..............: '+tostring(form201.text_3.value) font 'courier new' size 8
			@ 36, 10 print 'Tarjeta ............: '+form201.grid_2.cell(1,2) font 'courier new' size 8
			@ 40, 10 print 'Nombre .............: '+form201.grid_2.cell(2,2) font 'courier new' size 8
			@ 44, 10 print 'Direccion...........: '+form201.grid_2.cell(3,2) font 'courier new' size 8
			@ 50, 10 print 'FORMA DE PAGO' font 'courier new' size 9
			@ 54, 10 print 'Forma de pago ......: '+form201.combo_1.item(form201.combo_1.value) font 'courier new' size 8
			@ 58, 10 print 'Observaciones.......: '+form201.text_4.value font 'courier new' size 8
			@ 62, 10 print 'Cheque No ..........: '+form201.text_6.value font 'courier new' size 8
			@ 66, 10 print 'Banco...............: '+form201.text_5.value font 'courier new' size 8
			@ 70, 10 print 'Vencimiento.........: '+dtoc(form201.datepicker_2.value) font 'courier new' size 8
			@ 78, 10 print 'DETALLE DEL PAGO' font 'courier new' size 9
			subtitulo(82)
			r = 86
			for i= 1 to form201.grid_1.itemcount-1
				@ r, 10 print Subs(oData:acurso[form201.grid_1.cell(i,2)],1,30) font 'courier new' size 8
				@ r, 80 print Subs(form201.grid_1.cell(i,3),1,30) font 'courier new' size 8
				@ r,160 print transform(form201.grid_1.cell(i,5),'999,999') font 'courier new' size 8
				@ r,180 print transform(form201.grid_1.cell(i,6),'999,999') font 'courier new' size 8
				nIngreso += form201.grid_1.cell(i,5)
				nEgreso  += form201.grid_1.cell(i,6)
				r += 4
				If r > GetPrintableAreaHeight()-12
						PiePagina()
						End Printpage
						Start printpage
						Titulo('COMPROBANTE No '+Tostring(form201.text_1.value), form201.datepicker_1.value)
						@ 24, 10 print 'Boleta No ..........: '+tostring(form201.text_2.value) font 'courier new' size 8
						@ 28, 10 print 'DETALLE DEL PAGO' font 'courier new' size 8
						subtitulo(32)
						r = 36
				endif								
			next
			@ r-.5, 10 PRINT LINE TO r-.5, GetPrintableAreaWidth()-10 PENWIDTH .2	
			@ r, 10 print 'TOTALES' font 'courier new' size 8
			@ r,160 print transform(nIngreso,'999,999') font 'courier new' size 8
			@ r,180 print transform(nEgreso,'999,999') font 'courier new' size 8
			@ r+4, 10 PRINT LINE TO r+4, GetPrintableAreaWidth()-10 PENWIDTH .2	
			piepagina()
		end printpage
	end printdoc
	
return

static procedure subtitulo(r)
	@ r-.5, 10 PRINT LINE TO r-.5, GetPrintableAreaWidth()-10 PENWIDTH .2	
	@ r, 10 print 'Sevicio' font 'courier new' size 8
	@ r, 80 print 'Glosa' font 'courier new' size 8
	@ r,160 print 'Ingreso' font 'courier new' size 8
	@ r,180 print 'Egreso' font 'courier new' size 8
	@ r+4, 10 PRINT LINE TO r+4, GetPrintableAreaWidth()-10 PENWIDTH .2	
return

static procedure borrar(odata)
	if form201.text_1.value > 0
		buscar_rs( odata:mae, "idMaestro="+Tostring(form201.text_1.value))
		if oData:Mae:fields('estado'):value < 2
			if eliminar('Comprobante '+Tostring(form201.text_1.value))
				With object odata
				:mae:fields('estado'):Value := 2
				:Mae:update()
				end with
			endif
		else
			msgstop('No se puede eliminar comprobante nulo')
		endif
	endif
return

static procedure borrar_registro(odata)
	local n := form201.grid_1.value
	if oData:nEdit > 0
		if form201.grid_1.cell( form201.grid_1.value, 1 ) = 0
			return
		endif
		if msgyesno('Desea eliminar este registro','Confirmar')
			buscar_rs( odata:aux, "id="+tostring(form201.grid_1.cell(form201.grid_1.value,1)))
			odata:aux:delete()
			odata:aux:update()
			form201.grid_1.deleteitem( form201.grid_1.value )
			if form201.grid_1.itemcount = 0
				grid_eof('form201','grid_1')
				form201.grid_1.value := 1
			endif
			if form201.grid_1.itemcount < n
				form201.grid_1.value := form201.grid_1.itemcount
			else
				form201.grid_1.value := n
			endif
		endif
	endif
return

static procedure cerrar(odata)
	odata:mae:close()
	odata:aux:close()
	odata:socios:close()
	odata:fpago:close()
	odata:release()
return