#include <minigui.ch>
#include 'adodb.ch'

procedure proc401
	local nOpcion := 0
	local odata
	if oUser:nIdAcceso <> 1
		return
	endif
	
	if iswindowdefined( form401 )
		return
	endif
	
	with object (odata:= structure())
		:member('login', Openrecordset( oConexion, "Select * from login order by id"))
		:member('fields', {'id','nombre'})
	End with

		
	load window form401
	form401.center
	ON KEY ESCAPE OF Form401 ACTION estado_control(0)
	ON KEY DELETE OF form401 ACTION borrar(odata)
	activate window form401
	
return

static procedure muestra_datos(odata)
	llenar_grid( odata:login, odata:fields, 'form401','grid_1', .t.)
return 

static procedure muestra_registro(odata)
	local cPass := "", cNombre := "", cUsuario:= "", nTipo := 0
	if valtype( form401.grid_1.value ) != 'N'
		return
	endif
	if form401.grid_1.Itemcount > 0
		if buscar_rs( odata:login, "id="+ToString(form401.grid_1.cell( form401.grid_1.value, 1 )))
			cPass 	= odata:login:fields('pass'):value
			cNombre = odata:login:fields('nombre'):value
			cUsuario= odata:login:fields('usuario'):value
			nTipo	= odata:login:fields('idAcceso'):value
		endif
	endif
	form401.text_1.value	:= Decodifica(cPass)
	form401.text_2.value	:= cUsuario
	form401.text_3.value	:= cNombre
	form401.combo_1.value	:= if( nTipo = 0, 1, nTipo )
return	
					
static procedure estado_control(n)	
	if n = 3
		n = if( form401.grid_1.cell(form401.grid_1.value,1) = 0, 1, 2 )
	endif
	form401.text_1.enabled	:= if(n=0, .F., .T.)
	form401.text_2.enabled	:= if(n=0, .F., .T.)
	form401.text_3.enabled	:= if(n=0, .F., .T.)
	form401.combo_1.enabled	:= if(n=0, .F., .T.)
	form401.grid_1.enabled	:= if(n=0, .T., .F.)
	if n<>0
		form401.text_1.setfocus
	else
		form401.grid_1.setfocus
	endif		
return

static procedure borrar(odata)
	if Msgyesno('Desea eliminar a este usuario','Confirmar')
		buscar_rs( oData:login, "id="+ToString(form401.grid_1.cell(form401.grid_1.value,1)))
		oData:login:delete()
		oData:login:update()
		muestra_datos(odata)
	endif
return

static function guardar(odata)
	if form401.grid_1.cell(form401.grid_1.value,1) = 0
		odata:login:addnew()
	else
		buscar_rs(odata:login, "id="+tostring(form401.grid_1.cell( form401.grid_1.value, 1 )))
	endif
	odata:login:fields('idacceso'):value	:= form401.combo_1.value
	odata:login:fields('nombre'):value		:= form401.text_3.value
	odata:login:fields('usuario'):value		:= form401.text_2.value
	odata:login:fields('pass'):value		:= cerrar_clave() //form401.text_1.value
	odata:login:update()
	if form401.grid_1.cell(form401.grid_1.value,1) = 0
		odata:login:movelast()
		form401.grid_1.cell(form401.grid_1.value,1) := odata:login:fields('id'):value
	endif
	form401.grid_1.cell(form401.grid_1.value,2) := form401.text_3.value
	estado_control(0)
return .t.

static function validar_clave( ckey )
	local o := openrecordset( oConexion, "select * from login where pass='"+ckey+"'")
	local lexito 
	lExito = if( o:Recordcount > 0, .T., .F. )
	o:close()
return lExito

static procedure cerrar_clave()
return codifica( form401.text_2.value, form401.text_1.value)

static procedure abrir_clave(cclave)
return decodifica(cclave)

static procedure cerrar(odata)
	odata:login:close()
	odata:release()
return