#include 'Minigui.ch'
#include 'Adodb.ch'
*#include "winprint.ch"
#include "hbclass.ch"
MEMVAR xValue
MEMVAR _aTipos
//------------------------------
// Todas las funciones escritas aqui funcionan correctamente
//------------------------------

// Funciones y procedimientos publicos

// Procedure Llenar_Grid( oRs, aFields, cWin, cGrid, lEof )
// Procedure Grid_Grabar( nModo, cWin, cGrid, aValues )
// Procedure Grid_Ordenar( cWin, cGrid, nColumna )
// Function Borrar_Registro_Grid( cWin, cGrid )
// Function Grid_buscar( cWin, cGrid, cValor, nColumna )
// Function ToString( xValue )
// Procedure Grid_eof(cFrm, cGrd, aItems )
// Function Editar_Grid(ctit,x,c,w,albl,aval)
// Function Buscar_en_Lista( aLista, cValue )
// Function Buscar_Datos( aCampos )

// Funciones internas

// Static Procedure Control_Activo( aCtrl, aVal, albl )
// Static Function Asignar(aCtrl)
//------------------------------------------------------------------
// Funciones Genericas de base de datos
//------------------------------------------------------------------

Function OpenConnection( cDb )
	Local oConexion
	
	oConexion = TOleauto():New('ADODB.Connection')
	oConexion:ConnectionString ='Provider=Microsoft.Jet.OLEDB.4.0;'+;
								'Data Source='+cDb+';'+;
								'User Id=Admin;'+;
								"Password=;"
	oConexion:Open()

return oConexion

Function OpenRecordSet( oConexion, cSql )
	Local oTable := TOleAuto():New('ADODB.Recordset')
	oTable:CursorLocation = adUseClient
	oTable:Open( cSql, oConexion, adOpenDynamic, adLockOptimistic )
	if oTable:State = adStateClose
		Msgstop('No se pudo ejecutar la instruccion'+hb_osnewline()+cSql,'Error de apertura')
	Endif
Return oTable 	

FUNCTION FIND( ors, cCondicion )
	LOCAL lExito := false
	IF oRs:Recordcount > 0
		oRs:Movefirst()
		oRs:Find( cCondicion )
		lExito = if( oRs:eof(), .f., .t. )
	ENDIF	
RETURN lExito

Function Buscar_Rs( oRs, cCondicion )
	if oRs:Recordcount > 0
		oRs:MoveFirst()
		oRs:Find( cCondicion )
	Endif
Return if( oRs:Eof(), .f., .t. )

Function Buscar_Registro( oConn, cSql, cRetColumn )
	Local o := OpenRecordset( oConn, cSql )
	Local xRet := nil
	if o:Recordcount > 0
		xret = o:Fields( cRetColumn ):Value
	endif
	o:Close()
Return xret
//------------------------------------------------------------------
// Funciones Genericas para el grid
//------------------------------------------------------------------
Procedure UbicarPuntero( cWin, cGrd, Rs, cSql )
	Local nItemCount := 0, nValue := 0
	
	DECLARE WINDOW &cWin
	
	nItemCount 	= GetProperty( cWin, cGrd, 'Itemcount')
	nValue		= GetProperty( cWin, cGrd, 'Value')
	if nItemcount = 0 .or. nValue = 0
		Return		
	End
	if !Rs:Bof() .and. !Rs:Eof()
		Rs:MoveFirst()
		Rs:Find( cSql )
	End
	DoMethod(cWin,cGrd,'Setfocus')
	
Return
//------------------------------------------------------------------
Function Obtener_Registro( Rs, aFields )
	Local Aux := {}
	Local i:= 1
	
	For i= 1 To Len( aFields )	
		if Rs:Fields( aFields[i] ):ActualSize = adEmpty
			if rs:Fields( aFields[i] ):Type = adDate
				aadd( Aux, date())
			elseif rs:fields(afields[i]):Type >= 2 .and. rs:fields(afields[i]):Type<= 6
				aadd( Aux, 0 )
			elseif rs:fields(aFields[i]):Type = adBoolean
				aadd( Aux, .t. )
			elseif rs:fields(aFields[i]):Type = adChar .or. rs:fields(aFields[i]):Type = adWChar
				aadd( Aux, "" )
			else
				aadd( Aux, 0 )
			end			
		else
			if Rs:Fields( aFields[i] ):Type >= 2 .and. Rs:Fields( aFields[i] ):Type <= 6				
				aadd( Aux, Round( Rs:Fields( aFields[i] ):Value, 0 ) )
			else
				aadd( Aux, Rs:Fields( aFields[i] ):Value )
			endif
		endif			
	Next
	
Return aux
//------------------------------------------------------------------
Procedure Llenar_Grid( oRs, aFields, cWin, cGrid, lEof )
	// Llena un grid a partir de un objeto recordset
	// El arreglo aFields pasado como parametro tiene
	// el nombre de los campos a obtener del recordset
	
	Local r := Len( aFields )
	Local Aux := {}, aReg := {}
	
	DECLARE WINDOW &cWin

	DoMethod( cWin, cGrid, 'DeleteAllItems')
	if oRs:Recordcount > 0

		DoMethod( cWin, cGrid, 'DisableUpdate')
		oRs:MoveFirst()
	
		While !oRs:eof()
			Aux := Obtener_Registro( oRs, aFields )
			ADD ITEM Aux To &cGrid Of &cWin
			oRs:MoveNext()
		End
	
		DoMethod( cWin, cGrid, 'EnableUpdate')
	
		oRs:MoveFirst()
	End
	if lEof
		aReg = GetProperty( cWin, cGrid, 'Item', 1 )

		for i= 1 to len( Aux )
			aReg[i] = ToType( Aux[i] )			
		next
		ADD ITEM aReg To &cGrid Of &cWin	
	End
	SetProperty(cWin,cGrid,'Value',1)
	DoMethod(cWin,cGrid,'Setfocus')
	 
Return
//------------------------------------------------------------------
Procedure Grid_Grabar( nModo, cWin, cGrid, aValues )
	// Agrega o modifica un registro del grid
	// El parametro aValues contiene los valores a registrar en el grid
	// Estos valores son convertidos en esta funcion a caracter.
	Local i := 1
	
	#DEFINE _NUEVO 1
	#DEFINE _EDITAR 2
	
	DECLARE WINDOW &cWin

	For i= 1 To Len( aValues )
		aValues[i] = ToString( aValues[i] )
	Next
	
	If nModo = _NUEVO
		ADD ITEM aValues To &cGrid Of &cWin	
		i = GetProperty( cWin, cGrid, 'ItemCount')
	Elseif nModo = _EDITAR
		i = GetProperty( cWin, cGrid, 'Value')
		_SetItem( cGrid, cWin, i, aValues )
	End
	
	SetProperty( cWin, cGrid, 'Value', i )
	
	SETFOCUS &cGrid OF &cWin	
	
Return
//------------------------------------------------------------------
Procedure Grid_Ordenar( cWin, cGrid, nColumna )
	// Ordena un grid de acuerdo al numero de columna seleccionado
	Local aDatos := {}, aAux := {}
	Local i :=1, nPos := 0, nItemCount
	Local xvalue 
	DECLARE WINDOW &cWin
	
	nPos 		= GetProperty( cWin, cGrid, 'Value' )
	nItemcount 	= GetProperty( cWin, cGrid, 'Itemcount')
	xvalue 		= _Getitem( cGrid,cWin,npos)[nColumna]
	 
	FOR i= 1 TO nItemcount
		IF !EMPTY( _GetItem( cGrid, cWin, i )[nColumna] )
			AADD( aDatos, _GetItem( cGrid, cWin, i ))
		ELSE
			aAux := _GetItem( cGrid, cWin, i )
		END
	NEXT
	aDatos := ASORT( aDatos,,,{ |x,y| x[nColumna] < y[nColumna] } )
	DoMethod( cWin, cGrid, 'DeleteAllItems')
	FOR i= 1 TO LEN( aDatos )
		ADD ITEM aDatos[i] To &cGrid Of &cWin
	NEXT
	IF LEN( aAux ) > 0
		ADD ITEM aAux To &cGrid OF &cWin
	END
	
	npos = grid_buscar(cWin,cGrid, xvalue, nColumna )	
	
	SetProperty( cWin, cGrid, 'Value', nPos )
	SetFocus &cGrid Of &cWin

Return
//------------------------------------------------------------------
Function Borrar_Registro_Grid( cWin, cGrid )
	// Borra un determinada linea del grid.
	
	Local nPos := 0, nTotalRegistros := 0
	
	DECLARE WINDOW &cWin
	nPos = GetProperty( cWin, cGrid, 'Value')
	
	DELETE ITEM nPos FROM &cGrid OF &cWin

	nTotalRegistros = GetProperty( cWin, cGrid, 'Itemcount')
	
	nPos --
	
	If nPos > nTotalRegistros
		nPos := nTotalRegistros
	elseif nPos < 1
		nPos = 1
	End
	SetProperty( cWin, cGrid, 'Value', nPos )
	SetFocus &cGrid Of &cWin

Return nPos
//------------------------------------------------------------------
Function Grid_buscar( cWin, cGrid, cValor, nColumna )
	// Permite buscar un valor en un grid.
	Local nPos := 0, nTotalRegistros := 0, i := 1
	Local xValor 
	Local aRegistro
	
	nTotalRegistros = GetProperty( cWin, cGrid, 'Itemcount')
	
	For i= 1 To nTotalRegistros
		aRegistro := GetProperty( cWin, cGrid, 'ITEM', i )
		If Rat( Upper( cValor ), Upper( ToString(aRegistro[nColumna] ) ) ) != 0
			nPos = i
			Exit
		End
	Next
	
Return nPos
//------------------------------------------------------------------
Function Grid_buscar_multi( cWin, cGrid, aValor, aColumna )
	// Permite buscar un valor en un grid.
	Local nPos := 0, nTotalRegistros := 0, i := 1
	Local xValor 
	Local aRegistro
	
	nTotalRegistros = GetProperty( cWin, cGrid, 'Itemcount')
	
	For i= 1 To nTotalRegistros
		aRegistro := GetProperty( cWin, cGrid, 'ITEM', i )
		If Rat( Upper( aValor[1] ), Upper( aRegistro[aColumna[1]] ) ) != 0 .and. Rat( Upper( aValor[2] ), Upper( aRegistro[aColumna[2]] ) ) != 0
			nPos = i
			Exit
		End
	Next
	
Return nPos
//------------------------------------------------------------------
Function ToString( xxValue )
	// Convierte a String cualquier valor.
    Do Case
    Case Valtype(xxValue) = 'N'
    	xxvalue := alltrim(str( Round(xxValue,0) ))
    Case Valtype(xxValue) = 'D'
    	
    	xxValue := dtoc( xxValue )
    Case Valtype(xxValue) = 'L'
    	IF( xxValue, xxValue:= '.T.',xxValue := '.F.')
    Case Valtype(xxValue) = 'B'
    	xxValue = '{ || ... }'
    Case Valtype( xxValue ) = 'C' .or. Valtype( xxValue ) = 'M'
    		
    Case Valtype(xxValue) = NIL .or. Valtype(xxValue) = 'U'
    	xxValue := ""    	
    Otherwise
    	xxValue := ""
    EndCase
    
RETURN xxvalue
//------------------------------------------------------------------
Function ToType( xxValue )
	// Convierte a String cualquier valor.
    Do Case
    Case Valtype(xxValue) = 'N'
    	xxvalue := 0
    Case Valtype(xxValue) = 'D'
    	xxValue := date()
    Case Valtype(xxValue) = 'L'
    	xxValue := .t.
    Case Valtype( xxValue ) = 'C' .or. Valtype( xxValue ) = 'M'
    	xxValue := ""	
    Case Valtype(xxValue) = NIL .or. Valtype(xxValue) = 'U'
    	xxValue := ""    	
    Otherwise
    	xxValue := ""
    EndCase
    
RETURN xxvalue
//------------------------------------------------------------------
PROCEDURE Blank( cFrm, cGrd )
	// Permite agregar una linea vacia al final del grid y te posiciona en la nueva linea.
	// Se utiliza en el evento onchange del grid y despues de grabar datos.
	
	Local nValue, nItemCount
	Local aValue
	Local i := 1
		
	nItemcount 	= GetProperty( cFrm, cGrd, 'Itemcount')
	xValue 		= GetProperty( cFrm, cGrd, 'Item', 1 )
	
	for i= 1 to len( xValue )
		aValue[i] = ToType( xValue[i] )
	next		
	
	ADD ITEM aValue TO &cGrd OF &cFrm
	nItemcount ++
	SetProperty( cFrm, cGrd, 'Value', nItemCount )

RETURN

PROCEDURE Grid_eof(cFrm, cGrd, aItems )
	// Permite agregar una linea vacia al final del grid y te posiciona en la nueva linea.
	// Se utiliza en el evento onchange del grid y despues de grabar datos.
	
	Local nValue, nItemCount
	Local xValue
	Local i := 1
	Local Agregar := .f.
		
	nValue 		= GetProperty( cFrm, cGrd, 'Value')
	nItemcount 	= GetProperty( cFrm, cGrd, 'Itemcount')
	xValue 		= GetProperty( cFrm, cGrd, 'Item', nValue )[1] 

	if nValue = nItemcount .or. nItemcount = 0
		if valtype( xValue ) = 'N'
			if xValue <> 0 
				Agregar := .t.
			end
		elseif valtype( xValue ) = 'C'
			if len( xValue ) <> 0 
				Agregar = .t.
			end
		end
		if Agregar
			xValue 	= GetProperty( cFrm, cGrd, 'Item', nValue )
			for i= 1 to len( xValue )
				xValue[i] = ToType( xValue[i])
			next		
			ADD ITEM xValue TO &cGrd OF &cFrm
			nItemcount ++
			SetProperty( cFrm, cGrd, 'Value', nItemCount )
		end
		
	end

RETURN
//------------------------------------------------------------------
//FUNCTION Editar_Grid(ctit,x,c,w,albl,aval)
FUNCTION Editar_Grid(ctit,w,aval)
	// Crea una ventana de edicion.
	// Los parametros solicitados son :
	// Titulo, Row, Col, Width, aLabel, aVal
	// El parametro aVal debe ser un array por cada control { { label, Valor, bBloqueValid, lReadonly }, { label, aLista, nValor, bValid, lreadonly } }
	
	Local adatos := {}, actrl := {}, alabel:= {}
	local i := 1, r := 10, nh := 0
	local lReadOnly := .t.
	private clbl, ctrl
	
	nh = ( len( aVal ) * 24  ) + 110
	
	DEFINE WINDOW iw AT 0, 0 WIDTH w HEIGHT nh TITLE cTit ;
			TOPMOST ;
			NOMINIMIZE NOMAXIMIZE NOSIZE
	
		DEFINE STATUSBAR 
			CLOCK
			DATE
		END STATUSBAR
			
		For i= 1 To Len( aVal )
		
			clbl = 'label_'+Alltrim(str(i))
			ctrl = 'control_'+alltrim(str(i))
			if Valtype( aVal[i,2] ) = 'A'
				lReadonly:= if( len(aVal[i] )=4, .t., aVal[i,5] )
			else
				if len( aVal[i] ) = 4
					lReadonly = aVal[i,4]
				End
			End
			IF i = 1
				@ r, 10 label &clbl Value aVal[i,1]  width 100 BOLD
			ELSE
				@ r, 10 label &clbl Value aVal[i,1]  width 100 
			END		
			DO CASE
			CASE VALTYPE( aval[i,2] ) = 'N'
				DEFINE TEXTBOX &ctrl
					ROW r
					COL 120
					WIDTH ( w-130)
					HEIGHT 22
					VALUE aVal[i,2]
					NUMERIC .T.
					RIGHTALIGN .T.
					READONLY lReadOnly
					ON ENTER ( Control_Activo( aCtrl, aVal, alabel ))
					FONTNAME 'MS SANS SERIF'
					FONTSIZE 8
				END TEXTBOX
			CASE VALTYPE( aval[i,2] ) = 'C'
				DEFINE TEXTBOX &ctrl
					ROW r
					COL 120
					WIDTH ( w-130)
					HEIGHT 22
					VALUE aVal[i,2]
					RIGHTALIGN .F.
					READONLY lReadOnly
					ON ENTER ( Control_Activo( aCtrl, aVal, alabel ))
					FONTNAME 'MS SANS SERIF'
					FONTSIZE 8
				END TEXTBOX
			CASE VALTYPE( aval[i,2] ) = 'D'
				DEFINE DATEPICKER &Ctrl
					ROW r
					COL 120
					WIDTH ( w-130 )
					VALUE aVal[i,2]
					READONLY lReadOnly
					SHOWNONE .T.
					ON ENTER ( Control_Activo( aCtrl, aVal, alabel ))
					FONTNAME 'MS SANS SERIF'
					FONTSIZE 8
				END DATEPICKER
			CASE VALTYPE( aval[i,2] ) = 'A'
				DEFINE COMBOBOX &Ctrl
					ROW r
					COL 120
					WIDTH (w-130)
					ITEMS aVal[i,2]
					VALUE aVal[i,3]
					READONLY lReadonly
					ON ENTER ( Control_Activo( aCtrl, aVal, alabel ))
					FONTNAME 'MS SANS SERIF'
					FONTSIZE 8
				END COMBOBOX
			CASE VALTYPE( aVal[i,2] ) = 'M'
				DEFINE EDITBOX &Ctrl
					ROW r
					COL 120
					WIDTH (w-130)
					HEIGHT ( r+48 )
					VALUE aVal[i,2]
					READONLY lReadonly
					ON CHANGE ( M->xValue := GetProperty('iw',ctrl,'Value'), alabel )
					FONTNAME 'MS SANS SERIF'
					FONTSIZE 8
				END EDITBOX
				r +=24
				r +=24													 		
			ENDCASE
			
			AADD( actrl, ctrl )
			AADD( alabel, clbl )
			r += 24
			
		NEXT
		r += 20
		DEFINE BUTTON btn1
			ROW r
			COL w-170
			WIDTH 80
			HEIGHT 20
			CAPTION '&Aceptar'
			ACTION ( aDatos:=Asignar(aCtrl), iw.release )
			TOOLTIP 'Guardar cambios'
			FONTNAME 'MS SANS SERIF'
			FONTSIZE 8
		END BUTTON
		
		DEFINE BUTTON btn2
			ROW r
			COL w-90
			WIDTH 80
			HEIGHT 20
			CAPTION '&Cancelar'
			ACTION ( iw.release )
			TOOLTIP 'Salir sin grabar'
			FONTNAME 'MS SANS SERIF'
			FONTSIZE 8
		END BUTTON
		
	end window
	iw.center
	Activate window iw
RETURN aDatos
//------------------------------------------------------------------
Static Procedure Control_Activo( aCtrl, aVal, albl )

	// Procedimiento utilitario de la funcion Editar_Grid
	// Verifica que control tiene el foco y evalua si tiene un bloque valid el control
	// en caso de tenerlo lo ejecuta. Ademas pone en negrita el label del control activo.
	
	Local u := 0
	private cNombre_Control := iw.FocusedControl
	If Len( aCtrl ) = 0
		Return
	End
	
	for u=1 to len( albl )
		Setproperty( 'iw', albl[u],'fontbold',.f. )
	next
	u = 0
	u := Ascan( aCtrl, { |c| Upper( c ) = upper( cNombre_Control ) } )
	
	if u > 0
		M->xValue := GetProperty( 'iw', cNombre_Control,'Value')
		if Valtype( aVal[u,2] ) <> 'A'
			if Len( aVal[u] ) > 3
				If Valtype( aVal[u,3] ) = 'B' 
					if !Eval( aVal[u,3] )
						SETFOCUS &cNombre_Control Of iw
					End
				End
			end
		Elseif Valtype( aVal[u,2] ) = 'A'
			if Len( aVal[u] ) > 4
				If Valtype( aVal[u,4] ) = 'B' 
					if !Eval( aVal[u,4] )
						SETFOCUS &cNombre_Control Of iw
					End
				End
			end
		End
		SetProperty( 'iw', cNombre_Control, 'Value',  M->xValue )
		u ++
		if u <= len( albl )
			SetProperty( 'iw', albl[u], 'Fontbold', .t. )
		end	
	End	
Return 
//------------------------------------------------------------------
Static Function Asignar(aCtrl)
	// Funcion utilitaria de Editar_Grid.
	// Genera un arreglo con los valores de los controles para ser
	// devuelto al programa principal.
	 
	local aval := {}
	local i := 1
	local xval
	for i= 1 to len( actrl )
		xval = getproperty('iw',actrl[i],'value')
		aadd( aval, xval )
	next
Return aval

//------------------------------------------------------------------
Function Eliminar( cTexto )
	LOCAL LRESULT 
	IF PCOUNT() > 0
		LRESULT = Msgyesno('Desea eliminar este registro '+hb_osnewline()+cTexto,'Confirmar')
	ELSE
		LRESULT = Msgyesno('Desea eliminar este registro ','Confirmar')
	ENDIF
Return LRESULT

Function Eliminar_Comprobante()
Return Msgyesno('Desea eliminar este comprobante','Confirmar')

//------------------------------------------------------------------
Function Buscar_Datos( aCampos )
	Local aResp := { 0, "" }
	
	DEFINE WINDOW _Buscar AT 140 , 235 WIDTH 339 HEIGHT 164 ;
			TITLE "Buscar" MODAL NOSIZE 
			

    DEFINE LABEL Label_1
        ROW    20
        COL    20
        WIDTH  60
        HEIGHT 20
        VALUE "Campo"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        VISIBLE .T.
        TRANSPARENT .F.
    END LABEL

    DEFINE LABEL Label_2
        ROW    50
        COL    20
        WIDTH  60
        HEIGHT 20
        VALUE "Valor"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        VISIBLE .T.
        TRANSPARENT .F.
    END LABEL

    DEFINE COMBOBOX Combo_1
        ROW    20
        COL    100
        WIDTH  220
        HEIGHT 90
        ITEMS aCampos
        VALUE 1
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
    END COMBOBOX

    DEFINE TEXTBOX Text_1
        ROW    50
        COL    100
        WIDTH  220
        HEIGHT 24
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        VALUE ""
    END TEXTBOX

    DEFINE BUTTON Button_1
        ROW    90
        COL    120
        WIDTH  100
        HEIGHT 28
        CAPTION "&Aceptar"
        ACTION ( aResp[1]:= _buscar.combo_1.value, aResp[2]:= _buscar.text_1.value, _Buscar.Release )
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
    END BUTTON

    DEFINE BUTTON Button_2
        ROW    90
        COL    220
        WIDTH  100
        HEIGHT 28
        CAPTION "&Cancelar"
        ACTION _Buscar.Release
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
    END BUTTON

	END WINDOW
	_Buscar.Center
	Activate Window _Buscar
return aResp

Function Buscar_en_lista( aLista, cValue )
	Local nPos := 0, i := 1
	
	//nPos = Ascan( aLista, { | x | Rat( Upper(cValue), Upper(x) ) } )
	For i = 1 To Len( aLista )
		if Rat( Upper( cValue ),Upper( aLista[i] ) ) != 0
			nPos = i
			Exit
		End
	Next
	
Return nPos

Function Enviar_A()
	Local nOpcion := 0

	DEFINE 	WINDOW Enviara AT 137 , 235 WIDTH 279 HEIGHT 242 ;
			VIRTUAL WIDTH Nil VIRTUAL HEIGHT Nil ;
			TITLE "Opciones de salida" ICON NIL ;
			MODAL 

    DEFINE FRAME Frame_1
        ROW    10
        COL    10
        WIDTH  250
        HEIGHT 130
        FONTNAME "Arial"
        FONTSIZE 9
        OPAQUE .T.
    END FRAME
    
    DEFINE RADIOGROUP RadioGroup_1
        ROW    30
        COL    110
        WIDTH  140
        HEIGHT 100
        OPTIONS { 'Vista previa','Archivo Excel'}
        VALUE 1
        FONTNAME "Arial"
        FONTSIZE 9
        SPACING 25
    END RADIOGROUP

    DEFINE BUTTON Button_1
        ROW    160
        COL    20
        WIDTH  100
        HEIGHT 28
        CAPTION "&Aceptar"
        ACTION ( nOpcion:= enviara.radiogroup_1.value, enviara.release )
        FONTNAME "Arial"
        FONTSIZE 9
        TABSTOP .T.
        VISIBLE .T.
    END BUTTON

    DEFINE BUTTON Button_2
        ROW    160
        COL    150
        WIDTH  100
        HEIGHT 28
        CAPTION "&Cancelar"
        ACTION ( nOpcion := 0, Enviara.Release )
        FONTNAME "Arial"
        FONTSIZE 9
        TABSTOP .T.
        VISIBLE .T.
    END BUTTON

    DEFINE LABEL Label_3
        ROW    50
        COL    20
        WIDTH  70
        HEIGHT 60
        VALUE "Direccionar la salida del informe a"
        FONTNAME "Arial"
        FONTSIZE 9
        CENTERALIGN .T. 
    END LABEL

    DEFINE FRAME Frame_2
        ROW    150
        COL    10
        WIDTH  250
        HEIGHT 50
        FONTNAME "Arial"
        FONTSIZE 9
    END FRAME

	END WINDOW		
	Activate Window Enviara
Return nOpcion

Procedure Exportar_Excel( cTitle, aSubtitle, aDatos )
	Local oXls, oSheet
	Local i := 1, r := 3, j := 1
	
	oxls := TOleauto():New('Excel.Application')
	oxls:Workbooks:Add()
	
	oSheet:= oxls:ActiveSheet()
	
	*- Titulo del informe
	oSheet:Cells(1,1):Value := cTitle
	
	*- Subtitulo de las columnas
	For i= 1 to Len( aSubtitle )
		oSheet:Cells( 2, i ):Value := aSubtitle[i]
	Next
	
	*- Detalle del informe
	For i= 1 to Len(aDatos)
		For j= 1 to Len( aDatos[i] )
			oSheet:Cells(r,j):Value := aDatos[i,j]
		Next
		r ++
	Next
	
	oXls:Visible := .t.
	
Return

Procedure Exportar_Texto( cTitle, aSubtitle, aDatos )
	Local cTexto := ""
	Local i := 1, j := 1
	cTexto += cTitle +hb_osnewline()
	if Len( aSubtitle ) > 0
		For i = 1 to Len( aSubtitle )
			cTexto += aSubtitle[i]+';'
		Next
		cTexto += hb_osnewline()
	End
	
	For i= 1 to len( aDatos )
		for j = 1 to len( adatos[i] )
			ctexto+= adatos[i,j]+';'
		next
		ctexto += hb_osnewline()		
	Next
	
	Memowrit( 'Informe.txt', cTexto )
	msginfo('Se genero el archivo Informe.txt')
	
Return	

Procedure Exportar_html( cTitle, aSubtitle, aDatos )
	Local cTexto := ""
	Local i := 1, j := 1
	
	cTexto ='<html><head><title>'+ctitle+'</title></head><body><h1>'+cTitle+'</h1>'+;
			'<table border=1 width=80%>'
			
	cTexto += '<tr>'
	For i= 1 to len( aSubtitle )
		ctexto += '<td align=center><Font size=+1>'+aSubtitle[i]+'</font></td>'
	next
	ctexto += '</tr>'
	
	for i= 1 to Len( aDatos )
		cTexto += '<tr>'
		For j= 1 to len( aDatos[i] )
			ctexto += '<td>'+aDatos[i,j]+'</td>'
		next
		ctexto += '</tr>'	
	next
	
	cTexto +='</table></body></html>'
	
	MemoWrit('Informe.html', cTexto )
	Msginfo('Se genero el archivo Informe.html')
		
Return

FUNCTION DIGITO( aRut )
	local c1, c2, c3, c4, c5, c6, c7, c8, ddv, xrut
	local calc:= aux := 0
	xrut	= Alltrim( arut )
	c1=val(substr(xrut,01,1))
	c2=val(substr(xrut,02,1))
	c3=val(substr(xrut,03,1))
	c4=val(substr(xrut,04,1))
	c5=val(substr(xrut,05,1))
	c6=val(substr(xrut,06,1))
	c7=val(substr(xrut,07,1))
	c8=val(substr(xrut,08,1))
	calc= c1*3 + c2*2 + c3*7 + c4*6 + c5*5 + c6*4 + c7*3 + c8*2
	aux=calc-int(calc/11)*11
	if aux=0
  	 ddv='0'
	else
  	 if aux=1
    	  ddv='K'
	   else
  	    ddv=str((11-aux),1,0)
   	endif
	endif
RETURN ddv
//------------------------------------------------------------------
FUNCTION NumeroMes()
RETURN 	{'01','02','03','04','05','06','07','08','09','10','11','12'}
//------------------------------------------------------------------
FUNCTION NombreMes()
RETURN {'Enero','Febrero','Marzo','Abril','Mayo','Junio','Julio',;
	'Agosto','Septiembre','Octubre','Noviembre','Diciembre'}
//------------------------------------------------------------------
FUNCTION UltimoDiaMes( dfecha )
	LOCAL cDia := '', cMes := SUBS( DTOC( dFecha ), 4, 2 ), cAno := SUBS( DTOC( dFecha ), 7 )
	IF RAT( cMes, '01030507081012') != 0
		cDia ='31'
	ELSEIF RAT( cMes, '04060911') !=0
		cDia = '30'
	ELSE
		cDia := IF( Val( cAno ) / 2 = Int( Val(cAno)/2 ),'29','28')
	END
RETURN cDia
FUNCTION Quitar( cMensaje )
RETURN Msgyesno( cMensaje, 'Borrar' ) 

FUNCTION Consulta_Maestro( oRs, xFields, nColumnResult )
	Local aDatos := {}, Aux :={}, Ancho := {}, aOrder :={}
	Local nOrden := 1, nPos := 0, i := 1
	Local cResult := "", cTexto := "", aCtrl := {}, aValid:= {}
	Local aFields := {}
	
	cTexto ="Para buscar seleccione el nombre del campo en que quiere buscar e ingrese el valor. "+;
			"Si encontro el valor deseado seleccione la fila y presione Aceptar. "+;
			"Para abortar la seleccin presione Cerrar."
	if oRs:recordcount > 0
		oRs:Movefirst()
	else
		msgstop('No existen registros en la tabla')
		return  nil
	end
			
	for i= 1 to oRs:fields:count 
		aadd( aFields, oRs:fields(i-1):name )
	next
	aux = array( len( afields ) )
	ancho=Array( Len( aFields ) )
	Aux = Obtener_Registro( oRs, aFields )
	for i= 1 to len( Aux )
		Aux[i] = ToType( Aux[i] )

		if Valtype( Aux[i] ) = 'N'
			AADD( aCtrl,{'TEXTBOX','NUMERIC'})
		elseif Valtype( Aux[i] ) = 'D'
			AADD( aCtrl,{'TEXTBOX','DATE'})
		elseif Valtype( Aux[i] ) = 'L'
			AADD( aCtrl,{'CHECKBOX','Si','No'})
		else
			AADD( aCtrl,{'TEXTBOX','CHARACTER'})
		end
	next

	aadd( adatos, Aux )
	afill( Ancho, 80 )
	Aux = array( len( afields ) )	
	DEFINE WINDOW frm_consulta_maestro AT 140 , 235 WIDTH 588 HEIGHT 440 ;
			VIRTUAL WIDTH Nil VIRTUAL HEIGHT Nil ;
			TITLE "Buscar ..." ICON NIL ;
			MODAL CURSOR NIL ;
			ON INIT ( llenar_grid( oRs, aFields, 'frm_consulta_maestro','grid_1', .f.) ) 

    	DEFINE STATUSBAR FONT "Arial" SIZE 9
    	    STATUSITEM 'Cargando datos ...'
    	END STATUSBAR
    	
    	DEFINE GRID Grid_1
    	    ROW    70
    	    COL    10
    	    WIDTH  560
    	    HEIGHT 260
    	    ITEMS adatos
    	    VALUE 1
    	    WIDTHS Ancho
    	    HEADERS afields
    	    FONTNAME "Arial"
    	    FONTSIZE 9
    	    TOOLTIP ""
    	    ONCHANGE ( frm_consulta_maestro.statusbar.item(1):='Orden '+aFields[nOrden], cResult := frm_consulta_maestro.grid_1.cell( frm_consulta_maestro.grid_1.value, nColumnResult ) )
    	    ON DBLCLICK  ( frm_consulta_maestro.release )
    	    ONHEADCLICK aOrder
			COLUMNCONTROLS aCtrl
    	END GRID
    	
    	DEFINE LABEL Label_1
    	    ROW    340
    	    COL    10
    	    WIDTH  60
    	    HEIGHT 20
    	    VALUE "Buscar :"
    	    FONTNAME "Arial"
    	    FONTSIZE 9
    	    TOOLTIP ""
    	END LABEL
    	
    	DEFINE COMBOBOX Combo_datos	
    		ROW 340
    		COL 70
    		WIDTH 100
    		HEIGHT 200
    		ITEMS aFields
    		VALUE 1
    	END COMBOBOX
    	
    	DEFINE TEXTBOX Text_1
    	    ROW    340
    	    COL    180
    	    WIDTH  120
    	    HEIGHT 24
    	    FONTNAME "Arial"
    	    FONTSIZE 9
    	    TOOLTIP ""
    	    VALUE ""
    	END TEXTBOX
    	
    	DEFINE BUTTON Button_1
    	    ROW    340
    	    COL    310
    	    WIDTH  24
    	    HEIGHT 24
    	    CAPTION "..."
    	    ACTION ( nPos := Grid_buscar('frm_consulta_maestro','grid_1', frm_consulta_maestro.text_1.value, frm_consulta_maestro.combo_datos.value ),;
    	    		if( nPos > 0, frm_consulta_maestro.grid_1.value := npos, .t. ) )
    	    FONTNAME "Arial"
    	    FONTSIZE 9
    	    TOOLTIP "Iniciar busqueda"
    	END BUTTON
    	
    	DEFINE LABEL Label_2
    	    ROW    10
    	    COL    10
    	    WIDTH  560
    	    HEIGHT 50
    	    VALUE cTexto
    	    FONTNAME "Arial"
    	    FONTSIZE 9
    	    TOOLTIP ""
    	END LABEL
			
    	DEFINE BUTTON Button_2
    	    ROW    340
    	    COL    370
    	    WIDTH  100
    	    HEIGHT 28
    	    CAPTION "&Aceptar"
    	    ACTION ( frm_consulta_maestro.release )
    	    FONTNAME "Arial"
    	    FONTSIZE 9
    	    TOOLTIP ""
    	END BUTTON
    	
    	DEFINE BUTTON Button_3
    	    ROW    340
    	    COL    470
    	    WIDTH  100
    	    HEIGHT 28
    	    CAPTION "&Cerrar"
    	    ACTION ( cResult := nil, frm_consulta_maestro.release )
    	    FONTNAME "Arial"
    	    FONTSIZE 9
    	    TOOLTIP ""
    	END BUTTON

	END WINDOW
	frm_consulta_maestro.center
	Activate window frm_consulta_maestro
	
RETURN cResult	

FUNCTION Str_Zero( cValue, n )
	local x := LEN(ALLTRIM(cValue))
RETURN REPLICATE('0', n-x)+ALLTRIM(cValue)

Procedure TipoMenu()
	/*
	LOCAL aColors := GetMenuColors()

	aColors[ MNUCLR_MENUBARBACKGROUND1 ]  := GetSysColor( 15 )
	aColors[ MNUCLR_MENUBARBACKGROUND2 ]  := GetSysColor( 15 )
	aColors[ MNUCLR_MENUBARTEXT ]         := GetSysColor(  7 )
	aColors[ MNUCLR_MENUBARSELECTEDTEXT ] := GetSysColor( 14 )
	aColors[ MNUCLR_MENUBARGRAYEDTEXT ]   := GetSysColor( 17 )
	aColors[ MNUCLR_MENUBARSELECTEDITEM1 ]:= GetSysColor( 13 )
	aColors[ MNUCLR_MENUBARSELECTEDITEM2 ]:= GetSysColor( 13 )

	aColors[ MNUCLR_MENUITEMTEXT ]        := GetSysColor(  7 )  
	aColors[ MNUCLR_MENUITEMSELECTEDTEXT ]:= GetSysColor( 14 )  
	aColors[ MNUCLR_MENUITEMGRAYEDTEXT ]  := GetSysColor( 17 )   

	aColors[ MNUCLR_MENUITEMBACKGROUND1 ] := IF( _HMG_IsXP, GetSysColor( 4 ), RGB( 255, 255, 255 ) )
	aColors[ MNUCLR_MENUITEMBACKGROUND2 ] := IF( _HMG_IsXP, GetSysColor( 4 ), RGB( 255, 255, 255 ) )

	aColors[ MNUCLR_MENUITEMSELECTEDBACKGROUND1 ] := GetSysColor( 13 )
	aColors[ MNUCLR_MENUITEMSELECTEDBACKGROUND2 ] := GetSysColor( 13 )
	aColors[ MNUCLR_MENUITEMGRAYEDBACKGROUND1 ]   := IF( _HMG_IsXP, GetSysColor( 4 ), RGB( 255, 255, 255 ) )
	aColors[ MNUCLR_MENUITEMGRAYEDBACKGROUND2 ]   := IF( _HMG_IsXP, GetSysColor( 4 ), RGB( 255, 255, 255 ) )

	aColors[ MNUCLR_IMAGEBACKGROUND1 ] := GetSysColor( 15 )
	aColors[ MNUCLR_IMAGEBACKGROUND2 ] := GetSysColor( 15 )

	aColors[ MNUCLR_SEPARATOR1 ] := GetSysColor( 17 )
	aColors[ MNUCLR_SEPARATOR2 ] := GetSysColor( 14 )

	aColors[ MNUCLR_SELECTEDITEMBORDER1 ] := GetSysColor( 13 ) 
	aColors[ MNUCLR_SELECTEDITEMBORDER2 ] := GetSysColor( 13 )
	aColors[ MNUCLR_SELECTEDITEMBORDER3 ] := GetSysColor( 17 )
	aColors[ MNUCLR_SELECTEDITEMBORDER4 ] := GetSysColor( 14 )

	SET MENUCURSOR FULL

	SET MENUSEPARATOR DOUBLE RIGHTALIGN

	SET MENUITEM BORDER FLAT

	SetMenuColors( aColors )
	*/
return
//---------------------------------------------------------------------------
Procedure Titulo( cTitulo, dFecha )
	Local cFile := 'Logo.bmp'
	Local cEmp := Datos_Empresa()

	if File( cFile )
		@ 5, 10 print image "Logo.bmp" width 10 height 15 		
		@ 10,20 print cEmp
	else
		@ 10,20 print cEmp
	endif
	
	if pcount() = 1
		@ 10, GetPrintableAreaWidth() - 30 print dtoc( date() ) 
	elseif pcount() = 2
		@ 10, GetPrintableAreaWidth() - 30 print dtoc( dFecha ) 
	endif
	@ 14, (GetPrintableAreaWidth()/2) - ( LEN( cTitulo )/2 ) print cTitulo font 'fnt' 
	@ 18, 10 PRINT LINE TO 18, GetPrintableAreaWidth()-10 PENWIDTH .2
	
	//oEmp:Release()
Return
//---------------------------------------------------------------------------
Procedure Subtitulo( aSub )
	Local i := 1, r := 20
	For i= 1 to len( aSub )
		@ r, aSub[i,2] PRINT aSub[i,1] font 'fnt' 
	Next
	@ 24, 10 PRINT LINE TO  24, GetPrintableAreaWidth()-10 PENWIDTH .3
Return
//---------------------------------------------------------------------------
Procedure PiePagina()
	@ GetPrintableAreaHeight()-10, 10 PRINT LINE TO GetPrintableAreaHeight()-10, GetPrintableAreaWidth()-10 PENWIDTH .2
	@ GetPrintableAreaHeight()-5, GetPrintableAreaWidth()-30 PRINT 'Pagina : '+Alltrim( str( ++Pagina) ) 
Return

Procedure mostrar_error( oConexion, otbl )
	local oErr
	local i := 1
	local cErr:=""
	
	For i:= 1 to oConexion:Errors:Count					
		oErr := oConexion:Errors:item(i-1)
		cErr += ToString( oerr:number )+"="+oerr:description + hb_osnewline()						
	next
	if len( cerr ) > 0
		oTbl:CancelUpdate()
		if oTbl:Recordcount > 0
			oTbl:MoveLast()
		end
		Msginfo('Se produjo los siguientes errores'+hb_osnewline()+cErr,'Avise al administrador')
	end
return

*----------- --------- --------- --------- --------- --------- --
Function GetGridColumnsCount ( ControlName , ParentForm )
*----------- --------- --------- --------- --------- --------- --

Local i, nColumn

i := GetControlIndex( ControlName , ParentForm )

nColumn := Len( _HMG_SYSDATA [7][i] )

Return nColumn

procedure acercade(cPrograma)
	shellabout(""+cPrograma+"#Version 1.0")
return

Function Pronombre_Personal(cTexto)
Return Upper( subs(cTexto,1,1) )+Lower(subs(cTexto,2))

function codifica(cUsuario,cPass)
	local cKey := "", cChar := "", nAsc := 0
	local ctexto := ""
	local i := 1
	ctexto = cUsuario+'_'+cPass
	for i= 1 to len(ctexto)
		nAsc= asc(Subs(cTexto,i,1))
		cChar= str_zero(tostring(nAsc),3)
		cKey+= cChar
	next
return ckey

function decodifica(cpass)
	local cClave := ""
	local i :=1, r := 1, nAsc := 0, nIniciar := 0
	do while r < len( cPass )
		nasc = val(subs( cpass, r, 3 ))
		cClave += chr( nasc )
		r+=3
	enddo
	i = rat('_', cClave )
	cClave = Subs( cClave, i+1)
return cclave
