#include <minigui.ch>
#include 'adodb.ch'

procedure proc104
	Local oData
	
	if iswindowdefined( form104 )
		return
	endif
	
	oData:= Structure()
	oData:member("ColumnControls",{{'TEXTBOX','NUMERIC'},{'TEXTBOX','CHARACTER'}})
	oData:member("Headers",{'Codigo','Descripcion'})
	oData:member("Items", {{0,""}})
	oData:member("widths",{ 80, 200 })
	oData:member("TSocio", OpenRecordset(oConexion, "Select * from tipoSocios"))

	load window form104
	form104.center
	ON KEY ESCAPE OF Form104 ACTION estado_control(0)
	activate window form104
	
return

static procedure estado_control(n)
	local lNuevo := if(form104.grid_1.cell(form104.grid_1.value,1) = 0, .T., .F. )
	form104.text_1.enabled:= .f.
	form104.text_2.enabled:= .f.
	if n > 0		
		form104.grid_1.enabled:= .f.
		form104.text_2.enabled:= .t.
		form104.text_1.value	:= if( lNuevo, 0, form104.text_1.value)
		form104.text_2.value	:= if( lNuevo, "",form104.text_2.value)		
		form104.text_2.setfocus
		return
	endif
	form104.grid_1.enabled:= .t.
	form104.grid_1.setfocus
return

static procedure muestra_datos
	form104.text_1.value	:= form104.grid_1.cell(form104.grid_1.value,1)
	form104.text_2.value	:= form104.grid_1.cell(form104.grid_1.value,2)
return

static procedure carga_pagina( odata )
	With Object oData
		llenar_grid(:TSocio, {"IdTipo","Descripcion"}, "FORM104","Grid_1", .T.)
	End With
return

static function validar(odata)
	if empty( form104.text_2.value)
		msgstop('Ingrese descripcion')
		return .f.
	endif
	Try
		With Object oData
			if form104.text_1.value = 0
				:TSocio:Addnew()
			else
				buscar_rs(:TSocio, "idTipo="+tostring(form104.text_1.value))
			endif
			:TSocio:fields('descripcion'):value:= form104.text_2.value
			:TSocio:update()
			if form104.text_1.value = 0
				:TSocio:Movelast()
			endif
			form104.grid_1.cell(form104.grid_1.value,1):= :TSocio:fields('idTipo'):value
			form104.grid_1.cell(form104.grid_1.value,2):= :TSocio:fields('descripcion'):value
			grid_eof('form104','grid_1')
		End With	
	Catch e
		MsgStop("Operacin: "+e:operation+hb_osnewline()+"Descripcin: "+e:Description)	
		form104.release
	End Try
	estado_control(0)	
return

static procedure buscar
	local aResp := buscar_datos({'Codigo','Descripcion'})
	local npos  := 0
	if aResp[1] > 0
		npos = grid_buscar('form104','grid_1',aresp[2],aresp[1])
		if npos > 0
			form104.grid_1.value := npos
		else
			msgstop('Registro no encontrado')
		endif
	endif
return

static procedure borrar(odata)
	if form104.grid_1.cell(form104.grid_1.value,1) > 0
		if Eliminar()
			With Object oData
				if buscar_rs( :TSocio, "idTipo="+tostring(form104.grid_1.cell(form104.grid_1.value,1)))
					:TSocio:delete()
					:TSocio:update()
					form104.grid_1.deleteitem( form104.grid_1.value )
				endif
			End with
		endif
	endif
return

static procedure imprimir
	local r := 30
	
	Select printer Default Preview
	start printdoc
		start printpage
			M->Pagina := 0
			Titulo('TIPOS DE SOCIOS')
			Subtitulo({{'Codigo',10},{'Descripcion',30}})
			for i := 1 to form104.grid_1.itemcount-1
				@ r, 12 print form104.grid_1.cell(i,1) 
				@ r, 30 print form104.grid_1.cell(i,2) 
				r+=4
				if r > GetPrintableAreaHeight()-12
					PiePagina()
					End Printpage
					Start printpage
					Titulo('FORMAS DE PAGO')
					Subtitulo({{'Codigo',10},{'Descripcion',30}})
					r = 30
				endif										
			next
			Piepagina()
		end printpage
	end printdoc		
	
return

static procedure cerrar( o )
	o:TSocio:close()
	o:release()
return
	