#include <minigui.ch>
#include 'adodb.ch'

procedure proc107
	Local oData
	
	if iswindowdefined( form107 )
		return
	endif
	
	oData:= Structure()
	oData:member("ColumnControls",{{'TEXTBOX','NUMERIC'},{'TEXTBOX','CHARACTER'}})
	oData:member("Headers",{'Codigo','Descripcion'})
	oData:member("Items", {{0,""}})
	oData:member("widths",{ 80, 200 })
	oData:member("Cat", OpenRecordset(oConexion, "Select * from Categorias"))

	load window form107
	form107.center
	ON KEY ESCAPE OF Form107 ACTION estado_control(0)
	activate window form107
	
return

static procedure estado_control(n)
	local lNuevo := if(form107.grid_1.cell(form107.grid_1.value,1) = 0, .T., .F. )
	form107.text_1.enabled:= .f.
	form107.text_2.enabled:= .f.
	if n > 0		
		form107.grid_1.enabled:= .f.
		form107.text_2.enabled:= .t.
		form107.text_1.value	:= if( lNuevo, 0, form107.text_1.value)
		form107.text_2.value	:= if( lNuevo, "",form107.text_2.value)		
		form107.text_2.setfocus
		return
	endif
	form107.grid_1.enabled:= .t.
	form107.grid_1.setfocus
return

static procedure muestra_datos
	form107.text_1.value	:= form107.grid_1.cell(form107.grid_1.value,1)
	form107.text_2.value	:= form107.grid_1.cell(form107.grid_1.value,2)
return

static procedure carga_pagina( odata )
	With Object oData
		llenar_grid(:Cat, {"IdCategoria","Descripcion"}, "FORM107","Grid_1", .T.)
	End With
return

static function validar(odata)
	if empty( form107.text_2.value)
		msgstop('Ingrese descripcion')
		return .f.
	endif
	Try
		With Object oData
			if form107.text_1.value = 0
				:Cat:Addnew()
			else
				buscar_rs(:Cat, "IdCategoria="+tostring(form107.text_1.value))
			endif
			:Cat:fields('descripcion'):value:= form107.text_2.value
			:Cat:update()
			if form107.text_1.value = 0
				:Cat:Movelast()
			endif
			form107.grid_1.cell(form107.grid_1.value,1):= :Cat:fields('IdCategoria'):value
			form107.grid_1.cell(form107.grid_1.value,2):= :Cat:fields('descripcion'):value
			grid_eof('form107','grid_1')
		End With	
	Catch e
		MsgStop("Operacin: "+e:operation+hb_osnewline()+"Descripcin: "+e:Description)	
		form107.release
	End Try
	estado_control(0)	
return

static procedure buscar
	local aResp := buscar_datos({'Codigo','Descripcion'})
	local npos  := 0
	if aResp[1] > 0
		npos = grid_buscar('form107','grid_1',aresp[2],aresp[1])
		if npos > 0
			form107.grid_1.value := npos
		else
			msgstop('Registro no encontrado')
		endif
	endif
return

static procedure borrar(odata)
	if form107.grid_1.cell(form107.grid_1.value,1) > 0
		if Eliminar()
			With Object oData
				if buscar_rs( :Cat, "IdCategoria="+tostring(form107.grid_1.cell(form107.grid_1.value,1)))
					:Cat:delete()
					:Cat:update()
					form107.grid_1.deleteitem( form107.grid_1.value )
				endif
			End with
		endif
	endif
return

static procedure imprimir
	local r := 30
	
	Select printer Default Preview
	start printdoc
		start printpage
			M->Pagina := 0
			Titulo('CATEGORIAS')
			Subtitulo({{'Codigo',10},{'Descripcion',30}})
			for i := 1 to form107.grid_1.itemcount-1
				@ r, 12 print form107.grid_1.cell(i,1) 
				@ r, 30 print form107.grid_1.cell(i,2) 
				r+=4
				if r > GetPrintableAreaHeight()-12
					PiePagina()
					End Printpage
					Start printpage
					Titulo('CATEGORIAS')
					Subtitulo({{'Codigo',10},{'Descripcion',30}})
					r = 30
				endif										
			next
			Piepagina()
		end printpage
	end printdoc		
	
return

static procedure cerrar( o )
	o:Cat:close()
	o:release()
return
	