#include <minigui.ch>
#include 'adodb.ch'

procedure proc302
	local aDatos := {}
	local o 
	
	if iswindowdefined(form302)
		return
	endif
	o 		= Openrecordset( oConexion, "Select * from cuentas")
	adatos 	= carga_maestro(o)
	o:close()
	
	load window form302
	form302.center
	form302.spinner_1.value	:= Val( Subs( dtos(date()),1,4) )
	activate window form302

return

static procedure verifica_rango
	if form302.combo_1.value > form302.combo_2.value
		form302.combo_2.value := form302.combo_1.value
	endif
return

static procedure estado_control
	do case
	case form302.radiogroup_1.value = 1
		form302.spinner_1.enabled 	:= .f.
		form302.combo_1.enabled		:= .f.
		form302.combo_2.enabled		:= .f.
	case form302.radiogroup_1.value = 2
		form302.spinner_1.enabled 	:= .t.
		form302.combo_1.enabled		:= .f.
		form302.combo_2.enabled		:= .f.
	case form302.radiogroup_1.value = 3
		form302.spinner_1.enabled 	:= .t.
		form302.combo_1.enabled		:= .t.
		form302.combo_2.enabled		:= .t.
	endcase
return

static procedure ejecutar_informe
	local r := 26, x := 0, i := 0, j := 0, n := 0
	local aSub, aEstado :={'Disponible','No disponible'}, aAcumualdo := {}, aAux := {}
	local o, oaux, osoc
	local cAno	:= ToString( form302.spinner_1.value )
	
	Select printer Default Preview
	start printdoc
	
		do case
		case form302.radiogroup_1.value = 1
		
			o 	= Openrecordset( oConexion, "Select * from cuentas")
			aSub= {{'IdCurso',10},{'Descripcion',30},{'Estado',100}}
			
			start printpage
				M->Pagina := 0
				Titulo('LISTADO DE CURSOS/SERVICIOS')
				Subtitulo(asub)
				do while !o:eof()
					@ r, asub[1,2] print o:fields(0):value
					@ r, asub[2,2] print o:fields(1):value
					@ r, asub[3,2] print aEstado[if( o:fields(2):value > 0, o:Fields(2):value,1)]
					r+=4
					if r > GetPrintableAreaHeight()-12
						PiePagina()
						End Printpage
						Start printpage
						Titulo('LISTADO DE CURSOS/SERVICIOS')
						Subtitulo(asub)
						r = 26
					endif				
					o:MoveNext()						
				enddo
				Piepagina()
			end printpage
			o:close()
		
		case form302.radiogroup_1.value = 2
			//INFORME DE SALDOS ACUMULADOS POR SERVICIO.
		
			o 			:= Openrecordset(oConexion, "Select * from cuentas")
			aAcumulado	:= {}			
			do while !o:eof()			
				oAux:= Openrecordset(oConexion, "Select * from transaccionesAuxiliar "+;
												"where IdCurso="+tostring(o:fields('IdCurso'):Value)+" "+;
												"And fecha_emision LIKE '"+cAno+"%' "+;
												"Order by IdCurso")						
				if oAux:Recordcount > 0
					x 	:= 0
					aAux:= Array(13)
					Afill( aAux, 0 )
					oAux:Movefirst()
					do while ! oAux:eof()
						if x = 0
							aAux[1] = ToString(o:Fields('IdCurso'):Value)+'-'+Pronombre_personal( o:Fields(1):Value) 
							x 		= 1
						endif
						nMes 		  = val( subs( oAux:fields('fecha_emision'):value,5,2) ) + 1
						aAux[ nMes ] += 1
						aAux[ nMes ] += 1
						oAux:Movenext()
					enddo
					aadd( aAcumulado, aAux )
				endif
				oAux:Close()
				o:Movenext()
			enddo
			o:close()

			if Len(aAcumulado)> 0
				asub = {}
				aadd( aSub, {'Servicio',10})
				x = 70
				for i:= 1 to 12
					aadd( aSub, { Subs(NombreMes()[i],1,3),x})
					x +=10
				next

				start printpage
					M->Pagina := 0
					Titulo('LISTADO DE CURSOS/SERVICIOS ACUMULADO PERIODO '+cAno)
					Subtitulo(asub)
					For i:= 1 to len(aAcumulado)
						For x:= 1 to Len( aAcumulado[i] )							
							@ r, asub[x,2] print if( x=1, Subs(aAcumulado[i,x],1,40), aAcumulado[i,x])
						next
						r+=4
						if r > GetPrintableAreaHeight()-12
							PiePagina()
							End Printpage
							Start printpage
							Titulo('LISTADO DE CURSOS/SERVICIOS ACUMULADO PERIODO '+cAno)
							Subtitulo(asub)
							r = 26
						endif				
					next
					Piepagina()
				end printpage
			
			endif
			
		case form302.radiogroup_1.value = 3
			// DETALLE DE SALDOS POR PERIODO
			o 			:= Openrecordset(oConexion, "Select * from cuentas")
			aAcumulado	:= {}
			aSub 		:= {{'Folio',10},{'Socio',30},{'Emision',100},{'Vencto',120}}
			
			o:MoveFirst()
			
			Do While !o:EoF()
				if o:Fields('IdCurso'):value >= form302.combo_1.value .or. o:fields('IdCurso'):value <= form302.combo_2.value				
					oAux:= Openrecordset(oConexion, "SELECT * FROM TransaccionesAuxiliar Where (IdCurso="+ToString(o:Fields('IdCurso'):Value)+")")
					if oAux:RecordCount > 0		
						//msginfo( tostring(oaux:recordcount))		
						oAux:Movefirst()
						do while !oAux:eof()
							aAux:= {}
							if subs(oAux:fields('fecha_emision'):Value,1,4) = cAno
								aadd( aAux, o:Fields('IdCurso'):value)							
								aadd( aAux, oAux:Fields('Id'):value)
								aadd( aAux, oAux:fields('IdMaestro'):value)
								oSoc		:= Openrecordset(oConexion, "Select * from socios where idsocio="+ToString(oAux:fields('IdSocio'):value))
								if oSoc:RecordCount > 0
									aadd( aAux, Alltrim(oSoc:fields('nombres'):Value)+' '+;
												Alltrim(oSoc:Fields('Paterno'):value)+' '+;
												Alltrim(oSoc:fields('Materno'):value))
								else
									aadd( aAux, "" )
								Endif				
								oSoc:close()				
								aadd( aAux, stod(oAux:fields('fecha_emision'):value))
								aadd( aAux, stod(oAux:fields('fecha_vencimiento'):value))
								aadd( aAux, o:Fields('descripcion'):value)
							endif
							if len(aAux) > 0
								aadd( aAcumulado, aAux )
							endif
							oAux:MoveNext()
						enddo
					endif
					oAux:Close()
				endif				
				o:Movenext()				
			enddo
			
			if Len(aAcumulado)> 0
				//msginfo( str(len(aAcumulado)))
				start printpage
					M->Pagina := 0
					Titulo('LISTADO DE CURSOS/SERVICIOS DETALLE PERIODO '+cAno)
					subtitulo(asub)
					j = 0
					For i:= 1 to len(aAcumulado)	
						if aAcumulado[i,1] <> j 
							if i > 1
								r +=4
							endif
							@ r, 10 print if(form302.radiogroup_1.value=3, ToString(aAcumulado[i,2])+" "+aAcumulado[i,7], aAcumulado[i,2]) bold
							r += 4
							j = aAcumulado[i,1]
						endif
						@ r, asub[1,2] print tostring(aAcumulado[i,3])
						@ r, asub[2,2] print aAcumulado[i,4]
						@ r, asub[3,2] print aAcumulado[i,5]
						@ r, asub[4,2] print aAcumulado[i,6]
						r+=4
						if r > GetPrintableAreaHeight()-12
							PiePagina()
							End Printpage
							Start printpage
							Titulo('LISTADO DE CURSOS/SERVICIOS ACUMULADO PERIODO '+cAno)
							Subtitulo(asub)
							r = 26
						endif				
					next
					
					Piepagina()
					
				end printpage
			
			endif
			o:close()
		
		endcase
	end printdoc		
return